(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/cdk/coercion'), require('ts-md5/dist/md5')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/avatar', ['exports', '@angular/common', '@angular/core', '@angular/cdk/coercion', 'ts-md5/dist/md5'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components'].avatar = {}), global.ng.common, global.ng.core, global.ng.cdk.coercion, global.md5));
}(this, (function (exports, common, core, coercion, md5) { 'use strict';

    var PALETTE_SIZE = 16;
    var UxgImageAvatar = /** @class */ (function () {
        function UxgImageAvatar() {
        }
        return UxgImageAvatar;
    }());
    UxgImageAvatar.decorators = [
        { type: core.Directive, args: [{
                    selector: 'uxg-image-avatar, [uxg-image-avatar], [uxgImageAvatar]'
                },] }
    ];
    var AvatarComponent = /** @class */ (function () {
        function AvatarComponent() {
            this.color = 'gradient';
            this._dense = false;
            this.avatarImage = null;
        }
        Object.defineProperty(AvatarComponent.prototype, "dense", {
            get: function () {
                return this._dense;
            },
            set: function (value) {
                this._dense = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        AvatarComponent.prototype.getCode = function (str) {
            var charCodes = str
                .split('')
                .map(function (char) { return char.charCodeAt(0); })
                .join('');
            return parseInt(charCodes, 10);
        };
        AvatarComponent.prototype.generateGravatar = function () {
            var rand = Math.random()
                .toString(36)
                .replace(/[^a-z]+/g, '')
                .substr(0, 5);
            var gravatarHash = this.gravatarEmail ? md5.Md5.hashStr(this.gravatarEmail) : md5.Md5.hashStr(rand);
            this.gravatarUrl = "//gravatar.com/avatar/" + gravatarHash + "?s=512";
            if (this.defaultGravatar && !this.gravatarEmail) {
                this.gravatarUrl = this.gravatarUrl + "&default=" + this.defaultGravatar;
            }
        };
        AvatarComponent.prototype.ngOnInit = function () {
            if (this.name && this.color === 'initials') {
                this.paletteColor = (this.getCode(this.name) % PALETTE_SIZE) + 1;
            }
            if (this.gravatarEmail || this.defaultGravatar) {
                this.generateGravatar();
            }
            this.avatarContent = this._explicitContent || this.avatarImage || this._implicitContent;
        };
        return AvatarComponent;
    }());
    AvatarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-avatar',
                    template: "<div\n  class=\"uxg-avatar\"\n  [class.uxg-primary-color]=\"color === 'primary'\"\n  [class.uxg-accent-color]=\"color === 'accent'\"\n  [ngClass]=\"color === 'initials' ? 'uxg-avatar-color-' + paletteColor : ''\"\n  [class.uxg-gravatar]=\"gravatarEmail || defaultGravatar\"\n>\n  <ng-container *ngTemplateOutlet=\"avatarContent\"></ng-container>\n</div>\n\n<ng-template #implicitContent>\n  <img *ngIf=\"gravatarEmail || defaultGravatar; else nameAvatar\" [src]=\"gravatarUrl\" />\n  <ng-template #nameAvatar>\n    <ng-container *ngIf=\"name\">\n      {{ name | initials: dense }}\n    </ng-container>\n  </ng-template>\n</ng-template>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".uxg-avatar-color-1{background:rgba(var(--color-primary),1)}.uxg-avatar-color-2{background:#4538cb}.uxg-avatar-color-3{background:#2123c0}.uxg-avatar-color-4{background:#141483}.uxg-avatar-color-5{background:rgba(var(--color-primary-darker),1)}.uxg-avatar-color-6{background:rgba(var(--color-secondary),1)}.uxg-avatar-color-7{background:#ac258d}.uxg-avatar-color-8{background:#9d1880}.uxg-avatar-color-9{background:#910d75}.uxg-avatar-color-10{background:rgba(var(--color-secondary-darker),1)}.uxg-avatar-color-11{background:rgba(var(--color-warn),1)}.uxg-avatar-color-12{background:rgba(var(--color-warn-darker),1)}.uxg-avatar-color-13{background:#56c271}.uxg-avatar-color-14{background:#3c874e}.uxg-avatar-color-15{background:#ff8a3d}.uxg-avatar-color-16{background:#b2602a}.uxg-avatar-color-17{background:#f0b323}.uxg-avatar-color-18{background:#a87d18}.uxg-avatar-color-19{background:#5bc1d7}.uxg-avatar-color-20{background:#3f8696}.uxg-avatar-color-21{background:#d2d755}.uxg-avatar-color-22{background:#92963b}"]
                },] }
    ];
    /** @nocollapse */
    AvatarComponent.ctorParameters = function () { return []; };
    AvatarComponent.propDecorators = {
        name: [{ type: core.Input }],
        gravatarEmail: [{ type: core.Input }],
        defaultGravatar: [{ type: core.Input }],
        color: [{ type: core.Input }],
        dense: [{ type: core.Input }],
        avatarImage: [{ type: core.Input }],
        _explicitContent: [{ type: core.ContentChild, args: [UxgImageAvatar, { read: core.TemplateRef, static: true },] }],
        _implicitContent: [{ type: core.ViewChild, args: ['implicitContent', { static: true },] }]
    };

    var AvatarListComponent = /** @class */ (function () {
        function AvatarListComponent(dense, large, renderer) {
            this.dense = dense;
            this.large = large;
            this.renderer = renderer;
        }
        AvatarListComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.avatars.forEach(function (avatar, i) {
                _this.renderer.setStyle(avatar.nativeElement, 'z-index', _this.avatars.length - i);
            });
            if (this.totalLength) {
                this.extra = this.totalLength - this.avatars.length;
            }
        };
        return AvatarListComponent;
    }());
    AvatarListComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-avatar-list',
                    template: "<ul class=\"uxg-avatar-list\" [attr.dense]=\"dense === '' || null\" [attr.large]=\"large === '' || null\">\n  <ng-content select=\"uxg-avatar\"></ng-content>\n  <li class=\"uxg-avatar-number\">+{{ extra }}</li>\n</ul>\n"
                },] }
    ];
    /** @nocollapse */
    AvatarListComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Attribute, args: ['dense',] }] },
        { type: undefined, decorators: [{ type: core.Attribute, args: ['large',] }] },
        { type: core.Renderer2 }
    ]; };
    AvatarListComponent.propDecorators = {
        totalLength: [{ type: core.Input }],
        avatars: [{ type: core.ContentChildren, args: [AvatarComponent, { read: core.ElementRef },] }]
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var InitialsPipe = /** @class */ (function () {
        function InitialsPipe() {
        }
        InitialsPipe.prototype.transform = function (fullName, dense) {
            var _a = __read(fullName.split(' '), 2), name = _a[0], surname = _a[1];
            var initials = name.charAt(0).toUpperCase();
            if (!dense) {
                if (surname) {
                    initials += surname.charAt(0).toUpperCase();
                }
                else if (name.length >= 2) {
                    initials += name.charAt(1).toUpperCase();
                }
            }
            return initials;
        };
        return InitialsPipe;
    }());
    InitialsPipe.decorators = [
        { type: core.Pipe, args: [{
                    name: 'initials'
                },] }
    ];

    var AvatarModule = /** @class */ (function () {
        function AvatarModule() {
        }
        return AvatarModule;
    }());
    AvatarModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [AvatarComponent, AvatarListComponent, UxgImageAvatar, InitialsPipe],
                    exports: [AvatarComponent, AvatarListComponent, UxgImageAvatar, InitialsPipe]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AvatarComponent = AvatarComponent;
    exports.AvatarListComponent = AvatarListComponent;
    exports.AvatarModule = AvatarModule;
    exports.InitialsPipe = InitialsPipe;
    exports.UxgImageAvatar = UxgImageAvatar;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-avatar.umd.js.map
