(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/card'), require('@angular/material/divider'), require('@ffdc/uxg-angular-components/skeleton-text'), require('@angular/material/icon')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/cards/account-card', ['exports', '@angular/core', '@angular/common', '@angular/material/card', '@angular/material/divider', '@ffdc/uxg-angular-components/skeleton-text', '@angular/material/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components'].cards = global.ffdc['uxg-angular-components'].cards || {}, global.ffdc['uxg-angular-components'].cards['account-card'] = {}), global.ng.core, global.ng.common, global.ng.material.card, global.ng.material.divider, global.ffdc['uxg-angular-components']['skeleton-text'], global.ng.material.icon));
}(this, (function (exports, core, common, card, divider, skeletonText, icon) { 'use strict';

    var AccountCardComponent = /** @class */ (function () {
        function AccountCardComponent() {
            this.icon = 'credit_card';
            this.iconAriaLabel = 'Credit Card';
        }
        AccountCardComponent.prototype.ngOnInit = function () { };
        AccountCardComponent.prototype.ngOnDestroy = function () { };
        return AccountCardComponent;
    }());
    AccountCardComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-account-card',
                    template: "<mat-card>\n  <mat-card-content>\n    <div class=\"uxg-icon-category\">\n      <mat-icon aria-label=\"credit card icon\">credit_card</mat-icon>\n    </div>\n    <div class=\"uxg-body-1 account-name\">{{ name }}</div>\n    <div class=\"uxg-h5 account-balance\">{{ balance | currency: currency }}</div>\n  </mat-card-content>\n  <mat-card-footer>\n    <mat-divider></mat-divider>\n    <div class=\"uxg-body-2 account-number\">{{ number }}</div>\n  </mat-card-footer>\n</mat-card>\n",
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}:host{display:grid}:host mat-card{display:grid;min-width:200px}:host mat-card-content{display:grid;grid-template-columns:1fr 1fr 1fr 1fr;grid-column-gap:8px;grid-template-areas:\"icon name name menu\" \"icon balance balance balance\"}:host mat-card-content .uxg-icon-category{grid-area:icon;margin-top:4px;justify-self:center}:host mat-card-content .account-name{grid-area:name;align-self:end}:host mat-card-content .account-balance{grid-area:balance}:host mat-card-content .dropdown-menu{grid-area:menu;justify-self:end}:host .account-number{padding:8px 16px}"]
                },] }
    ];
    AccountCardComponent.propDecorators = {
        name: [{ type: core.Input }],
        balance: [{ type: core.Input }],
        currency: [{ type: core.Input }],
        number: [{ type: core.Input }],
        icon: [{ type: core.Input }],
        iconAriaLabel: [{ type: core.Input }]
    };
    // Skeleton
    var AccountCardSkeletonComponent = /** @class */ (function () {
        function AccountCardSkeletonComponent() {
        }
        return AccountCardSkeletonComponent;
    }());
    AccountCardSkeletonComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-account-card-skeleton',
                    template: "<mat-card>\n  <mat-card-content>\n    <div class=\"uxg-icon-category\">\n      <mat-icon></mat-icon>\n    </div>\n    <uxg-skeleton-text class=\"account-name\" animated></uxg-skeleton-text>\n    <uxg-skeleton-text class=\"account-balance\" animated></uxg-skeleton-text>\n  </mat-card-content>\n  <mat-card-footer>\n    <mat-divider></mat-divider>\n    <div class=\"account-number\">\n      <uxg-skeleton-text animated></uxg-skeleton-text>\n    </div>\n  </mat-card-footer>\n</mat-card>\n",
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}:host{display:grid}:host mat-card{display:grid;min-width:200px}:host mat-card-content{display:grid;grid-template-columns:1fr 1fr 1fr 1fr;grid-column-gap:8px;grid-template-areas:\"icon name name menu\" \"icon balance balance balance\"}:host mat-card-content .uxg-icon-category{grid-area:icon;margin-top:4px;justify-self:center}:host mat-card-content .account-name{grid-area:name;align-self:end}:host mat-card-content .account-balance{grid-area:balance}:host mat-card-content .dropdown-menu{grid-area:menu;justify-self:end}:host .account-number{padding:8px 16px}"]
                },] }
    ];

    var AccountCardModule = /** @class */ (function () {
        function AccountCardModule() {
        }
        return AccountCardModule;
    }());
    AccountCardModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [AccountCardComponent, AccountCardSkeletonComponent],
                    imports: [card.MatCardModule, divider.MatDividerModule, common.CommonModule, icon.MatIconModule, skeletonText.SkeletonTextModule],
                    exports: [AccountCardComponent, AccountCardSkeletonComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AccountCardComponent = AccountCardComponent;
    exports.AccountCardModule = AccountCardModule;
    exports.AccountCardSkeletonComponent = AccountCardSkeletonComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-cards-account-card.umd.js.map
