(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('angular-plotly.js'), require('@ffdc/uxg-angular-components/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/chart', ['exports', '@angular/core', '@angular/common', 'angular-plotly.js', '@ffdc/uxg-angular-components/core', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components'].chart = {}), global.ng.core, global.ng.common, global.angularPlotly_js, global.ffdc['uxg-angular-components'].core, global.rxjs));
}(this, (function (exports, core, common, angularPlotly_js, core$1, rxjs) { 'use strict';

    var _a;
    var CHART_DEFAULT_PLOTLY_LAYOUT = {
        autosize: true,
        margin: {
            l: 0,
            r: 0,
            b: 0,
            t: 0,
            pad: 0
        }
    };
    var CHART_DEFAULT_PLOTLY_CONFIG = {
        displaylogo: false,
        responsive: true
    };
    (function (ChartType) {
        ChartType["bar"] = "bar";
        ChartType["stackedBar"] = "stackedBar";
        ChartType["line"] = "line";
        ChartType["scatter"] = "scatter";
        ChartType["scatterLine"] = "scatterLine";
        ChartType["stackedLine"] = "stackedLine";
        ChartType["fullStackedLine"] = "fullStackedLine";
        ChartType["spline"] = "spline";
        ChartType["stackedSpline"] = "stackedSpline";
        ChartType["fullStackedSpline"] = "fullStackedSpline";
        ChartType["stepline"] = "stepline";
        ChartType["steparea"] = "steparea";
        ChartType["area"] = "area";
        ChartType["stackedArea"] = "stackedArea";
        ChartType["fullStackedArea"] = "fullStackedArea";
        ChartType["pie"] = "pie";
        ChartType["donut"] = "donut";
    })(exports.ChartType || (exports.ChartType = {}));
    (function (ChartOrientation) {
        ChartOrientation["horizontal"] = "horizontal";
        ChartOrientation["vertical"] = "vertical";
    })(exports.ChartOrientation || (exports.ChartOrientation = {}));
    var CHART_PLOLTLY_TYPE = (_a = {},
        _a[exports.ChartType.bar] = {
            name: 'bar',
            group: 'bar',
            trace: {
                type: 'bar'
            },
            layout: {
                barmode: 'group'
            }
        },
        _a[exports.ChartType.stackedBar] = {
            name: 'stackedBar',
            group: 'bar',
            trace: {
                type: 'bar'
            },
            layout: {
                barmode: 'relative'
            }
        },
        _a[exports.ChartType.line] = {
            name: 'line',
            group: 'line',
            trace: {
                type: 'scatter'
            }
        },
        _a[exports.ChartType.scatter] = {
            name: 'scatter',
            group: 'line',
            trace: {
                type: 'scatter',
                mode: 'markers'
            }
        },
        _a[exports.ChartType.scatterLine] = {
            name: 'scatter+line',
            group: 'line',
            trace: {
                type: 'scatter',
                mode: 'lines+markers'
            }
        },
        _a[exports.ChartType.stackedLine] = {
            name: 'Stacked line',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one',
                fill: 'none'
            }
        },
        _a[exports.ChartType.fullStackedLine] = {
            name: 'Full stacked line',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one',
                groupnorm: 'percent',
                fill: 'none'
            }
        },
        _a[exports.ChartType.spline] = {
            name: 'Spline',
            group: 'line',
            trace: {
                type: 'scatter',
                line: { shape: 'spline' }
            }
        },
        _a[exports.ChartType.stackedSpline] = {
            name: 'Stacked spline',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one',
                mode: 'lines+markers',
                fill: 'none',
                line: { shape: 'spline' }
            }
        },
        _a[exports.ChartType.fullStackedSpline] = {
            name: 'Full stacked spline',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one',
                groupnorm: 'percent',
                mode: 'lines+markers',
                fill: 'none',
                line: { shape: 'spline' }
            }
        },
        _a[exports.ChartType.stepline] = {
            name: 'Stepline',
            group: 'line',
            trace: {
                type: 'scatter',
                line: { shape: 'hv' }
            }
        },
        _a[exports.ChartType.steparea] = {
            name: 'Step area',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one',
                line: { shape: 'hv' }
            }
        },
        _a[exports.ChartType.area] = {
            name: 'Area',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one'
            }
        },
        _a[exports.ChartType.stackedArea] = {
            name: 'Stacked area',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one'
            }
        },
        _a[exports.ChartType.fullStackedArea] = {
            name: 'Full stacked area',
            group: 'line',
            trace: {
                type: 'scatter',
                stackgroup: 'one',
                groupnorm: 'percent'
            }
        },
        _a[exports.ChartType.pie] = {
            name: 'pie',
            group: 'pie',
            trace: {
                type: 'pie'
            }
        },
        _a[exports.ChartType.donut] = {
            name: 'donut',
            group: 'pie',
            trace: {
                type: 'pie',
                hole: 0.5,
                automargin: true,
                textposition: 'inside'
            }
        },
        _a);

    var TraceComponent = /** @class */ (function () {
        function TraceComponent() {
            this.type = exports.ChartType.bar;
            this.orientation = exports.ChartOrientation.vertical;
        }
        TraceComponent.prototype.getPlotlyTrace = function () {
            var plotlyType = CHART_PLOLTLY_TYPE[this.type];
            if (plotlyType) {
                var trace = Object.assign(Object.assign(Object.assign({ dimensionName: this.dimensionName, x: this.orientation === exports.ChartOrientation.vertical ? this.dimension : this.measure, y: this.orientation === exports.ChartOrientation.vertical ? this.measure : this.dimension, labels: this.orientation === exports.ChartOrientation.vertical ? this.dimension : this.measure, values: this.orientation === exports.ChartOrientation.vertical ? this.measure : this.dimension, name: this.measureName }, (plotlyType ? plotlyType.trace : {})), { orientation: this.orientation === exports.ChartOrientation.horizontal ? 'h' : 'v' }), (this.options ? this.options : {}));
                if (this.selectedPoints) {
                    trace.selectedpoints = Array.from(this.selectedPoints);
                }
                return trace;
            }
            console.error('Chart type: ' + this.type + " doesn't exist!");
            return {};
        };
        TraceComponent.prototype.getPlotlyTypeLayout = function () {
            var plotlyType = CHART_PLOLTLY_TYPE[this.type];
            return plotlyType && plotlyType.layout ? plotlyType.layout : {};
        };
        return TraceComponent;
    }());
    TraceComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-trace',
                    template: ''
                },] }
    ];
    /** @nocollapse */
    TraceComponent.ctorParameters = function () { return []; };
    TraceComponent.propDecorators = {
        dimension: [{ type: core.Input }],
        dimensionName: [{ type: core.Input }],
        measure: [{ type: core.Input }],
        measureName: [{ type: core.Input }],
        selectedPoints: [{ type: core.Input }],
        type: [{ type: core.Input }],
        orientation: [{ type: core.Input }],
        options: [{ type: core.Input }]
    };

    var GroupTracesComponent = /** @class */ (function () {
        function GroupTracesComponent() {
        }
        GroupTracesComponent.prototype.getTraces = function () {
            var _this = this;
            return this.traces
                .map(function (trace) {
                var t = trace.getPlotlyTrace();
                if (t && (_this.columnPosition !== undefined || _this.columnPosition !== undefined))
                    t.domain = _this.domain;
                return t;
            })
                .filter(function (trace) { return !!trace; });
        };
        Object.defineProperty(GroupTracesComponent.prototype, "domain", {
            get: function () {
                var domain = {};
                if (this.columnPosition !== undefined) {
                    domain.column = this.columnPosition;
                }
                if (this.rowPosition !== undefined) {
                    domain.row = this.rowPosition;
                }
                return domain;
            },
            enumerable: false,
            configurable: true
        });
        return GroupTracesComponent;
    }());
    GroupTracesComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-group-traces',
                    template: ''
                },] }
    ];
    GroupTracesComponent.propDecorators = {
        columnPosition: [{ type: core.Input }],
        rowPosition: [{ type: core.Input }],
        traces: [{ type: core.ContentChildren, args: [TraceComponent,] }]
    };

    var _a$1;
    var LegendComponent = /** @class */ (function () {
        function LegendComponent() {
            this.position = exports.LegendPosition.verticalRightTop;
        }
        LegendComponent.prototype.getLegendPlotly = function () {
            return LegendPositionConvertion[this.position] ? LegendPositionConvertion[this.position] : {};
        };
        return LegendComponent;
    }());
    LegendComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-legend',
                    template: ''
                },] }
    ];
    /** @nocollapse */
    LegendComponent.ctorParameters = function () { return []; };
    LegendComponent.propDecorators = {
        position: [{ type: core.Input }]
    };
    (function (LegendPosition) {
        LegendPosition["verticalLeftCenter"] = "verticalLeftCenter";
        LegendPosition["verticalLeftTop"] = "verticalLeftTop";
        LegendPosition["verticalLeftBottom"] = "verticalLeftBottom";
        LegendPosition["verticalRightCenter"] = "verticalRightCenter";
        LegendPosition["verticalRightTop"] = "verticalRightTop";
        LegendPosition["verticalRightBottom"] = "verticalRightBottom";
        LegendPosition["horizontalTopCenter"] = "horizontalTopCenter";
        LegendPosition["horizontalTopLeft"] = "horizontalTopLeft";
        LegendPosition["horizontalTopRight"] = "horizontalTopRight";
        LegendPosition["horizontalBottomCenter"] = "horizontalBottomCenter";
        LegendPosition["horizontalBottomLeft"] = "horizontalBottomLeft";
        LegendPosition["horizontalBottomRight"] = "horizontalBottomRight";
    })(exports.LegendPosition || (exports.LegendPosition = {}));
    var LegendPositionConvertion = (_a$1 = {},
        _a$1[exports.LegendPosition.verticalLeftTop] = {
            label: 'Vertical left top',
            orientation: 'v',
            x: -0.1,
            y: 1
        },
        _a$1[exports.LegendPosition.verticalLeftCenter] = {
            label: 'Vertical left center',
            orientation: 'v',
            x: -0.1,
            y: 0.5
        },
        _a$1[exports.LegendPosition.verticalLeftBottom] = {
            label: 'Vertical left bottom',
            orientation: 'v',
            x: -0.1,
            y: 0
        },
        _a$1[exports.LegendPosition.verticalRightTop] = {
            label: 'Vertical right top',
            orientation: 'v'
        },
        _a$1[exports.LegendPosition.verticalRightCenter] = {
            label: 'Vertical right center',
            orientation: 'v',
            x: 1,
            y: 0.5
        },
        _a$1[exports.LegendPosition.verticalRightBottom] = {
            label: 'Vertical right bottom',
            orientation: 'v',
            x: 1,
            y: 0
        },
        _a$1[exports.LegendPosition.horizontalBottomLeft] = {
            label: 'Horizontal bottom left',
            orientation: 'h',
            x: 0,
            y: -0.1,
            xanchor: 'left'
        },
        _a$1[exports.LegendPosition.horizontalBottomCenter] = {
            label: 'Horizontal bottom center',
            orientation: 'h',
            x: 0.5,
            y: -0.1,
            xanchor: 'center'
        },
        _a$1[exports.LegendPosition.horizontalBottomRight] = {
            label: 'Horizontal bottom right',
            orientation: 'h',
            x: 1,
            y: -0.1,
            xanchor: 'right'
        },
        _a$1[exports.LegendPosition.horizontalTopLeft] = {
            label: 'Horizontal top left',
            orientation: 'h',
            x: 0,
            y: 1.1,
            xanchor: 'left'
        },
        _a$1[exports.LegendPosition.horizontalTopCenter] = {
            label: 'Horizontal top center',
            orientation: 'h',
            x: 0.5,
            y: 1.1,
            xanchor: 'center'
        },
        _a$1[exports.LegendPosition.horizontalTopRight] = {
            label: 'Horizontal top right',
            orientation: 'h',
            x: 1.02,
            y: 1.1,
            xanchor: 'right'
        },
        _a$1);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var ChartComponent = /** @class */ (function () {
        function ChartComponent(document, paletteService, cd, lazyLoadScriptService) {
            this.document = document;
            this.paletteService = paletteService;
            this.cd = cd;
            this.lazyLoadScriptService = lazyLoadScriptService;
            this.data = [];
            this.subscriptions = [];
            this.multiSelect = false;
            this.lastClick = {
                time: 0,
                item: { selectedItems: [], clickedItems: [] }
            };
            this.onClick = new core.EventEmitter();
            this.onSelected = new core.EventEmitter();
            this.onDoubleClick = new core.EventEmitter();
            this.plotlyReady$ = lazyLoadScriptService.load('plotly.js', 'Plotly');
        }
        Object.defineProperty(ChartComponent.prototype, "config", {
            get: function () {
                return !this._config ? CHART_DEFAULT_PLOTLY_CONFIG : this._config;
            },
            set: function (value) {
                this._config = this.merge_options(CHART_DEFAULT_PLOTLY_CONFIG, value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartComponent.prototype, "layout", {
            get: function () {
                return this._layout ? this._layout : {};
            },
            set: function (value) {
                if (!this._defaultLayout)
                    this.setDefautLayout();
                this._layout = this.merge_options(this.merge_options(this._defaultLayout, this._layout), value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ChartComponent.prototype, "revision", {
            get: function () {
                return this.plot.revision;
            },
            set: function (value) {
                if (this.plot) {
                    this.refresh();
                    this.plot.revision = value;
                    this.cd.markForCheck();
                    this.plot.updatePlot();
                }
            },
            enumerable: false,
            configurable: true
        });
        ChartComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.setDefautLayout();
            this.subscriptions.push(this.paletteService.paletteChange$.subscribe(function (config) {
                _this.paletteConfig = config;
            }));
        };
        ChartComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.refresh();
            if (this.groupTraces && this.traces) {
                rxjs.merge(this.groupTraces.changes, this.traces.changes).subscribe(function (value) {
                    _this.refresh();
                });
            }
            else if (this.traces) {
                rxjs.merge(this.traces.changes).subscribe(function (value) {
                    _this.refresh();
                });
            }
            else if (this.groupTraces) {
                rxjs.merge(this.groupTraces.changes).subscribe(function (value) {
                    _this.refresh();
                });
            }
        };
        ChartComponent.prototype.ngOnDestroy = function () {
            this.subscriptions.forEach(function (subscription) { return subscription.unsubscribe(); });
        };
        ChartComponent.prototype.ngOnChanges = function (changes) {
            this.setData();
            this.setLayout();
        };
        ChartComponent.prototype.onSelect = function (event) {
            var _this = this;
            var points = event.points;
            var items = { selectedItems: new Array(), clickedItems: new Array() };
            var trace;
            points.forEach(function (item) {
                var _j, _k;
                var _a, _b, _c, _d, _e, _f, _g, _h;
                if (_this.traces) {
                    trace = _this.traces.find(function (t) {
                        return t.dimensionName === item.data.dimensionName && t.measureName === item.data.name;
                    });
                }
                else if (_this.groupTraces) {
                    _this.groupTraces.forEach(function (g) {
                        trace = g.traces.find(function (t) {
                            return t.dimensionName === item.data.dimensionName && t.measureName === item.data.name;
                        });
                    });
                }
                if (trace) {
                    if (item.pointIndex !== undefined) {
                        var dimension_1 = item.data.orientation === 'v' ? item.data.x[item.pointIndex] : item.data.y[item.pointIndex];
                        var measure_1 = item.data.orientation === 'v' ? item.data.y[item.pointIndex] : item.data.x[item.pointIndex];
                        // Get item clicked
                        items.clickedItems.push((_j = {},
                            _j[item.data.dimensionName] = dimension_1,
                            _j[item.data.name] = measure_1,
                            _j));
                        // Update selectedpoints
                        if (trace.selectedPoints && trace.selectedPoints.indexOf(item.pointIndex) !== -1) {
                            if (!_this.multiSelect) {
                                // Set other trace selection to null
                                (_a = _this.groupTraces) === null || _a === void 0 ? void 0 : _a.forEach(function (g) {
                                    var _a;
                                    (_a = g.traces) === null || _a === void 0 ? void 0 : _a.forEach(function (t) { return delete t.selectedPoints; });
                                });
                                (_b = _this.traces) === null || _b === void 0 ? void 0 : _b.forEach(function (t) { return delete t.selectedPoints; });
                            }
                            else {
                                var someSelected_1 = false;
                                (_c = _this.groupTraces) === null || _c === void 0 ? void 0 : _c.forEach(function (g) {
                                    var _a;
                                    (_a = g.traces) === null || _a === void 0 ? void 0 : _a.forEach(function (t) {
                                        var _a, _b;
                                        if ((t.dimensionName !== (trace === null || trace === void 0 ? void 0 : trace.dimensionName) || t.measureName !== (trace === null || trace === void 0 ? void 0 : trace.measureName)) && ((_a = t.selectedPoints) === null || _a === void 0 ? void 0 : _a.length) &&
                                            ((_b = t.selectedPoints) === null || _b === void 0 ? void 0 : _b.length) > 0)
                                            someSelected_1 = true;
                                    });
                                });
                                (_d = _this.traces) === null || _d === void 0 ? void 0 : _d.forEach(function (t) {
                                    var _a, _b;
                                    if ((t.dimensionName !== (trace === null || trace === void 0 ? void 0 : trace.dimensionName) || t.measureName !== (trace === null || trace === void 0 ? void 0 : trace.measureName)) && ((_a = t.selectedPoints) === null || _a === void 0 ? void 0 : _a.length) &&
                                        ((_b = t.selectedPoints) === null || _b === void 0 ? void 0 : _b.length) > 0)
                                        someSelected_1 = true;
                                });
                                if (trace.selectedPoints.length === 1 && !someSelected_1) {
                                    delete trace.selectedPoints;
                                }
                                else {
                                    trace.selectedPoints.splice(trace.selectedPoints.indexOf(item.pointIndex), 1);
                                }
                                if (!someSelected_1) {
                                    (_e = _this.groupTraces) === null || _e === void 0 ? void 0 : _e.forEach(function (g) {
                                        var _a;
                                        (_a = g.traces) === null || _a === void 0 ? void 0 : _a.forEach(function (t) {
                                            var _a;
                                            if ((t.dimensionName !== (trace === null || trace === void 0 ? void 0 : trace.dimensionName) || t.measureName !== (trace === null || trace === void 0 ? void 0 : trace.measureName)) &&
                                                ((_a = t.selectedPoints) === null || _a === void 0 ? void 0 : _a.length) === 0)
                                                delete t.selectedPoints;
                                        });
                                    });
                                    (_f = _this.traces) === null || _f === void 0 ? void 0 : _f.forEach(function (t) {
                                        var _a;
                                        if ((t.dimensionName !== (trace === null || trace === void 0 ? void 0 : trace.dimensionName) || t.measureName !== (trace === null || trace === void 0 ? void 0 : trace.measureName)) &&
                                            ((_a = t.selectedPoints) === null || _a === void 0 ? void 0 : _a.length) === 0)
                                            delete t.selectedPoints;
                                    });
                                }
                            }
                        }
                        else {
                            if (trace.selectedPoints && _this.multiSelect) {
                                trace.selectedPoints.push(item.pointIndex);
                            }
                            else {
                                // Set other trace selection to empty
                                (_g = _this.groupTraces) === null || _g === void 0 ? void 0 : _g.forEach(function (g) {
                                    var _a;
                                    (_a = g.traces) === null || _a === void 0 ? void 0 : _a.forEach(function (t) { return (t.selectedPoints = []); });
                                });
                                (_h = _this.traces) === null || _h === void 0 ? void 0 : _h.forEach(function (t) { return (t.selectedPoints = []); });
                                trace.selectedPoints = [item.pointIndex];
                            }
                        }
                        // Get items selected
                        if (trace.selectedPoints) {
                            trace.selectedPoints.forEach(function (index) {
                                var _j;
                                dimension_1 = item.data.orientation === 'v' ? item.data.x[index] : item.data.y[index];
                                measure_1 = item.data.orientation === 'v' ? item.data.y[index] : item.data.x[index];
                                items.selectedItems.push((_j = {},
                                    _j[item.data.dimensionName] = dimension_1,
                                    _j[item.data.name] = measure_1,
                                    _j));
                            });
                        }
                    }
                    else if (item.pointNumber !== undefined) {
                        items.selectedItems.push((_k = {},
                            _k[item.data.dimensionName] = item.data.labels[item.pointNumber],
                            _k[item.data.name] = item.data.values[item.pointNumber],
                            _k));
                        items.clickedItems = items.selectedItems;
                    }
                }
            });
            this.onEventClick(items);
        };
        ChartComponent.prototype.onEventClick = function (items) {
            var _this = this;
            var clickTime = Date.now();
            if (clickTime - this.lastClick.time < 250 &&
                this.lastClick.item &&
                this.lastClick.item.clickedItems &&
                this.lastClick.item.clickedItems.length) {
                clearTimeout(this.clickTimer);
                this.clickTimer = null;
                this.onDoubleClick.emit(this.lastClick.item.clickedItems);
            }
            else {
                this.lastClick.time = clickTime;
                this.lastClick.item = items;
                this.clickTimer = setTimeout(function () {
                    _this.lastClick.item = { selectedItems: [], clickedItems: [] };
                    _this.onClick.emit(items.selectedItems.length ? items.clickedItems : []);
                    _this.onSelected.emit(items.selectedItems);
                    clearTimeout(_this.clickTimer);
                    _this.revision++;
                }, 300);
            }
        };
        ChartComponent.prototype.refresh = function () {
            this.setLayout();
            this.setData();
            this.cd.markForCheck();
        };
        ChartComponent.prototype.merge_options = function (obj1, obj2) {
            var obj3 = {};
            if (typeof obj2 === 'undefined') {
                return obj1;
            }
            if (typeof obj1 === 'undefined') {
                return obj2;
            }
            for (var attrname in obj1) {
                if (obj1.hasOwnProperty(attrname))
                    obj3[attrname] =
                        typeof obj1[attrname] === 'object' && !Array.isArray(obj1[attrname])
                            ? this.merge_options(obj1[attrname], obj2[attrname])
                            : obj1[attrname];
            }
            for (var attrname in obj2) {
                if (obj2.hasOwnProperty(attrname))
                    obj3[attrname] =
                        typeof obj2[attrname] === 'object' && !Array.isArray(obj2[attrname])
                            ? this.merge_options(obj1[attrname], obj2[attrname])
                            : obj2[attrname];
            }
            return obj3;
        };
        ChartComponent.prototype.setDefautLayout = function () {
            var themeContent = this.document.body;
            var tmpContent = document.createElement('chart-font');
            tmpContent.className = 'chart-font';
            tmpContent.style.display = 'none';
            themeContent.appendChild(tmpContent);
            var globalStyled = window.getComputedStyle(this.document.body.getElementsByTagName('chart-font')[0]);
            tmpContent.className = 'chart-font-legend';
            var legendStyled = window.getComputedStyle(this.document.body.getElementsByTagName('chart-font')[0]);
            tmpContent.className = 'chart-font-axis';
            var axisStyled = window.getComputedStyle(this.document.body.getElementsByTagName('chart-font')[0]);
            this._defaultLayout = {
                hovermode: 'closest',
                clickmode: 'event',
                margin: {
                    t: 20,
                    l: 20,
                    r: 20,
                    b: 20
                },
                paper_bgcolor: 'transparent',
                plot_bgcolor: 'transparent',
                legend: {
                    font: {
                        family: legendStyled.fontFamily,
                        size: legendStyled.fontSize,
                        color: legendStyled.color
                    }
                },
                xaxis: {
                    automargin: true,
                    tickfont: {
                        family: axisStyled.fontFamily,
                        size: axisStyled.fontSize,
                        color: axisStyled.color
                    },
                    title: {
                        font: {
                            family: axisStyled.fontFamily,
                            size: axisStyled.fontSize,
                            color: axisStyled.color
                        }
                    }
                },
                yaxis: {
                    automargin: true,
                    tickfont: {
                        family: axisStyled.fontFamily,
                        size: axisStyled.fontSize,
                        color: axisStyled.color
                    },
                    title: {
                        font: {
                            family: axisStyled.fontFamily,
                            size: axisStyled.fontSize,
                            color: axisStyled.color
                        }
                    }
                },
                font: {
                    family: globalStyled.fontFamily,
                    size: globalStyled.fontSize,
                    color: globalStyled.color
                },
                bargap: parseFloat(axisStyled.margin ? axisStyled.margin.replace('px', '') : '10') / 100,
                bargroupgap: parseFloat(axisStyled.padding ? axisStyled.padding.replace('px', '') : '10') / 100
            };
            themeContent.removeChild(tmpContent);
        };
        ChartComponent.prototype.setLayout = function (layout) {
            if (!this._layout)
                this._layout = this._defaultLayout;
            if (this._layout) {
                if (this.groupTraces && !this._layout.grid) {
                    var row_1 = 0, column_1 = 0;
                    this.groupTraces.forEach(function (grpTraces) {
                        row_1 = row_1 < grpTraces.rowPosition ? grpTraces.rowPosition : row_1;
                        column_1 = column_1 < grpTraces.columnPosition ? grpTraces.columnPosition : column_1;
                    });
                    this._layout.grid = { rows: Number(row_1) + 1, columns: Number(column_1) + 1, pattern: 'independent' };
                }
                this._layout.legend = !!this.legend;
                if (this.legend) {
                    this._layout.legend = Object.assign(Object.assign({}, this._layout.legend), this.legend.getLegendPlotly());
                }
                if (this.paletteConfig && this.paletteConfig.colorWay) {
                    this._layout.colorway = this.paletteConfig.colorWay;
                }
            }
            if (layout) {
                this.merge_options(this._layout, layout);
            }
        };
        ChartComponent.prototype.setData = function () {
            if (this.traces && this.traces.length) {
                this.data = this.traces
                    .map(function (trace) {
                    return trace.getPlotlyTrace();
                })
                    .filter(function (trace) { return !!trace; });
            }
            else if (this.groupTraces && this.groupTraces.length) {
                var datas_1 = [];
                var nbGrp_1 = 1;
                this.groupTraces.forEach(function (grpTrace) {
                    datas_1 = __spread(datas_1, grpTrace.getTraces().map(function (tr) {
                        tr.xaxis = 'x' + nbGrp_1;
                        tr.yaxis = 'y' + nbGrp_1;
                        tr.legendgroup = 'group' + nbGrp_1;
                        return tr;
                    }));
                    nbGrp_1++;
                });
                this.data = datas_1;
            }
        };
        return ChartComponent;
    }());
    ChartComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-chart',
                    template: "<plotly-plot\n  *ngIf=\"plotlyReady$ | async\"\n  #plot\n  [data]=\"data\"\n  [layout]=\"layout\"\n  [config]=\"config\"\n  [useResizeHandler]=\"true\"\n  (plotly_click)=\"onSelect($event)\"\n>\n</plotly-plot>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}uxg-chart,uxg-chart .js-plotly-plot,uxg-chart plotly-plot{flex:auto;display:flex;flex-direction:column}.chart-font-axis{padding:24px;margin:48px}"]
                },] }
    ];
    /** @nocollapse */
    ChartComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
        { type: core$1.PaletteService },
        { type: core.ChangeDetectorRef },
        { type: core$1.LazyloadScriptService }
    ]; };
    ChartComponent.propDecorators = {
        plot: [{ type: core.ViewChild, args: [angularPlotly_js.PlotComponent, { static: false },] }],
        traces: [{ type: core.ContentChildren, args: [TraceComponent,] }],
        legend: [{ type: core.ContentChild, args: [LegendComponent, { static: false },] }],
        groupTraces: [{ type: core.ContentChildren, args: [GroupTracesComponent,] }],
        multiSelect: [{ type: core.Input }],
        config: [{ type: core.Input }],
        layout: [{ type: core.Input }],
        revision: [{ type: core.Input }],
        onClick: [{ type: core.Output }],
        onSelected: [{ type: core.Output }],
        onDoubleClick: [{ type: core.Output }]
    };

    var ChartModule = /** @class */ (function () {
        function ChartModule(lazyLoadScriptService) {
            lazyLoadScriptService.load('plotly.js', 'Plotly').subscribe(function (plotly) {
                angularPlotly_js.PlotlyService.setPlotly(plotly);
            });
        }
        return ChartModule;
    }());
    ChartModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, angularPlotly_js.PlotlyViaCDNModule],
                    declarations: [ChartComponent, GroupTracesComponent, LegendComponent, TraceComponent],
                    exports: [ChartComponent, GroupTracesComponent, LegendComponent, TraceComponent]
                },] }
    ];
    /** @nocollapse */
    ChartModule.ctorParameters = function () { return [
        { type: core$1.LazyloadScriptService }
    ]; };

    /**
     * Generated bundle index. Do not edit.
     */

    exports.CHART_DEFAULT_PLOTLY_CONFIG = CHART_DEFAULT_PLOTLY_CONFIG;
    exports.CHART_DEFAULT_PLOTLY_LAYOUT = CHART_DEFAULT_PLOTLY_LAYOUT;
    exports.CHART_PLOLTLY_TYPE = CHART_PLOLTLY_TYPE;
    exports.ChartComponent = ChartComponent;
    exports.ChartModule = ChartModule;
    exports.GroupTracesComponent = GroupTracesComponent;
    exports.LegendComponent = LegendComponent;
    exports.LegendPositionConvertion = LegendPositionConvertion;
    exports.TraceComponent = TraceComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-chart.umd.js.map
