(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/checkbox'), require('@angular/material/table'), require('@angular/animations'), require('@angular/cdk/collections'), require('@angular/material/expansion'), require('@ffdc/uxg-angular-components/core'), require('lodash/cloneDeep'), require('lodash/filter'), require('lodash/find'), require('lodash/groupBy'), require('lodash/isEqual'), require('lodash/map'), require('lodash/omit'), require('lodash/reject'), require('@ffdc/uxg-angular-components/table')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/expandable-table', ['exports', '@angular/common', '@angular/core', '@angular/material/button', '@angular/material/icon', '@angular/material/checkbox', '@angular/material/table', '@angular/animations', '@angular/cdk/collections', '@angular/material/expansion', '@ffdc/uxg-angular-components/core', 'lodash/cloneDeep', 'lodash/filter', 'lodash/find', 'lodash/groupBy', 'lodash/isEqual', 'lodash/map', 'lodash/omit', 'lodash/reject', '@ffdc/uxg-angular-components/table'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['expandable-table'] = {}), global.ng.common, global.ng.core, global.ng.material.button, global.ng.material.icon, global.ng.material.checkbox, global.ng.material.table, global.ng.animations, global.ng.cdk.collections, global.ng.material.expansion, global.ffdc['uxg-angular-components'].core, global.cloneDeep, global.filter, global.find, global.groupBy, global.isEqual, global.map, global.omit, global.reject, global.ffdc['uxg-angular-components'].table));
}(this, (function (exports, common, core, button, icon, checkbox, table, animations, collections, expansion, core$1, cloneDeep, filter, find, groupBy, isEqual, map, omit, reject, table$1) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var cloneDeep__default = /*#__PURE__*/_interopDefaultLegacy(cloneDeep);
    var filter__default = /*#__PURE__*/_interopDefaultLegacy(filter);
    var find__default = /*#__PURE__*/_interopDefaultLegacy(find);
    var groupBy__default = /*#__PURE__*/_interopDefaultLegacy(groupBy);
    var isEqual__default = /*#__PURE__*/_interopDefaultLegacy(isEqual);
    var map__default = /*#__PURE__*/_interopDefaultLegacy(map);
    var omit__default = /*#__PURE__*/_interopDefaultLegacy(omit);
    var reject__default = /*#__PURE__*/_interopDefaultLegacy(reject);

    var ExpandableTableComponent = /** @class */ (function () {
        function ExpandableTableComponent() {
            this.startExpanded = false;
            this.rowClick = new core.EventEmitter();
            this.selectionChange = new core.EventEmitter();
            this.tableButtonsCallBack = new core.EventEmitter();
            this.tableHeaderCallBack = new core.EventEmitter();
            this.dataLength = 0;
            this.selectionModel = new collections.SelectionModel(true, []);
            this.primaryKey = 'primaryKey';
            this.dataSource = [];
            this._dataSource = [];
            this.columns = [];
            this._columns = [];
            this.visibleColumns = [];
            this.selectable = false;
            this.rowClickable = false;
            this.groupByKey = 'id';
            this.chain = core$1.createChain({ map: map__default['default'], groupBy: groupBy__default['default'], filter: filter__default['default'], find: find__default['default'], isEqual: isEqual__default['default'], reject: reject__default['default'] });
        }
        ExpandableTableComponent.prototype.ngOnChanges = function (changes) {
            if (this.groupByKey && this.columns && this.dataSource) {
                this.selectionModel = new collections.SelectionModel(true, []);
                this.generateColumns();
                this.generateData();
            }
        };
        ExpandableTableComponent.prototype.generateData = function () {
            var _this = this;
            // add primaryKey
            var primaryKeyValue = 0;
            this.dataSource.forEach(function (data) {
                data[_this.primaryKey] = ++primaryKeyValue;
            });
            // input selection
            if (this.selection) {
                var initialSelection_1 = [];
                this.selection.forEach(function (selectionData) {
                    _this.dataSource.forEach(function (data) {
                        if (isEqual__default['default'](omit__default['default'](data, 'primaryKey'), omit__default['default'](selectionData, 'primaryKey'))) {
                            initialSelection_1.push(data);
                        }
                    });
                });
                this.selectionModel = new collections.SelectionModel(true, initialSelection_1);
            }
            this.dataLength = this.dataSource.length;
            this.dataSource = filter__default['default'](this.dataSource, function (data) {
                return data[_this.groupByKey];
            });
            this._dataSource = this.groupBy(this.groupByKey, this.dataSource);
        };
        ExpandableTableComponent.prototype.generateColumns = function () {
            var _this = this;
            if (!this.groupByKeyLabel) {
                this.groupByKeyLabel = this.groupByKey;
            }
            this.groupInfo = find__default['default'](this.columns, function (c) { return c.name === _this.groupByKeyLabel; });
            this._columns = reject__default['default'](this.columns, function (c) { return c.name === _this.groupByKeyLabel; });
            this.visibleColumns = this._columns.map(function (c) { return c.name; });
        };
        ExpandableTableComponent.prototype.groupBy = function (groupId, collection) {
            var _this = this;
            var dataSource = this.chain(collection)
                .groupBy(groupId)
                .map(function (values, id) { return ({
                id: id,
                label: _this.groupByKeyLabel ? values[0][_this.groupByKeyLabel] : groupId,
                values: values,
                expanded: _this.startExpanded
            }); })
                .value();
            dataSource.forEach(function (ds) {
                if (!ds.values[0][_this.visibleColumns[1]]) {
                    ds.values = [];
                }
            });
            return dataSource;
        };
        // All
        ExpandableTableComponent.prototype.toggleAll = function () {
            var _this = this;
            if (this.selectionModel.selected.length && this.isAllSelected()) {
                this.selectionModel.selected.forEach(function (item) {
                    _this.selectionModel.toggle(item);
                });
            }
            else {
                this._dataSource.forEach(function (row) {
                    row.values.forEach(function (item) { return _this.selectionModel.select(item); });
                });
            }
            this.onSelectionChanged();
        };
        ExpandableTableComponent.prototype.isAllSelected = function () {
            return this.selectionModel.selected.length === this.dataLength;
        };
        // Row level
        ExpandableTableComponent.prototype.toggleRow = function (row) {
            var _this = this;
            var selected = this.getSelectionByRow(row);
            if (selected && selected.length === row.values.length) {
                selected.forEach(function (item) {
                    _this.selectionModel.toggle(item);
                });
            }
            else {
                row.values.forEach(function (item) { return _this.selectionModel.select(item); });
            }
            this.onSelectionChanged();
        };
        ExpandableTableComponent.prototype.selectionHasRowValue = function (row) {
            return this.getSelectionByRow(row).length > 0;
        };
        ExpandableTableComponent.prototype.isRowAllSelected = function (row) {
            return this.getSelectionByRow(row).length === row.values.length;
        };
        ExpandableTableComponent.prototype.getSelectionByRow = function (row) {
            var _a;
            return filter__default['default'](this.selectionModel.selected, (_a = {}, _a[this.groupByKey] = row.id, _a));
        };
        ExpandableTableComponent.prototype.collapseAll = function () {
            if (!this.accordion)
                return;
            if (this._dataSource.some(function (row) { return row.expanded; })) {
                this.accordion.closeAll();
            }
            else {
                this.accordion.openAll();
            }
        };
        ExpandableTableComponent.prototype.getSelectedKeys = function (row) {
            var _this = this;
            var keys = [];
            var prediction = {};
            row.values.forEach(function (value, key) {
                prediction[_this.primaryKey] = value[_this.primaryKey];
                if (find__default['default'](_this.selectionModel.selected, prediction)) {
                    keys.push(key);
                }
            });
            return keys;
        };
        ExpandableTableComponent.prototype.onTableSelectionChange = function (tableSelectionEvent, row) {
            var _this = this;
            var rowSelection = this.getSelectionByRow(row);
            if (tableSelectionEvent.data) {
                rowSelection.forEach(function (selection) {
                    _this.selectionModel.toggle(selection);
                });
                tableSelectionEvent.data.forEach(function (selection) {
                    _this.selectionModel.toggle(selection);
                });
                this.onSelectionChanged();
            }
        };
        ExpandableTableComponent.prototype.onSelectionChanged = function () {
            var _this = this;
            var selectedItems = cloneDeep__default['default'](this.selectionModel.selected);
            selectedItems.forEach(function (data) {
                delete data[_this.primaryKey];
            });
            this.selectionChange.emit(selectedItems);
        };
        ExpandableTableComponent.prototype.onRowClicked = function (event) {
            if (this.rowClick) {
                this.rowClick.emit(event.data);
            }
        };
        return ExpandableTableComponent;
    }());
    ExpandableTableComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-expandable-table',
                    template: "<div class=\"expandable-table-header\">\n  <mat-checkbox\n    class=\"check-box-header\"\n    (click)=\"$event.stopPropagation()\"\n    [checked]=\"selectionModel.selected.length > 0 && isAllSelected()\"\n    [indeterminate]=\"selectionModel.selected.length > 0 && !isAllSelected()\"\n    (change)=\"$event ? toggleAll() : null\"\n    *ngIf=\"selectable\"\n    color=\"primary\"\n  >\n  </mat-checkbox>\n  <div class=\"title uxg-subtitle-1\" [ngClass]=\"{ selectable: selectable }\">\n    {{ groupInfo?.displayName || groupInfo?.name }}\n  </div>\n\n  <div class=\"up-down\">\n    <button mat-icon-button (click)=\"collapseAll(); $event.stopPropagation()\" [disableRipple]=\"true\">\n      <mat-icon>code</mat-icon>\n    </button>\n  </div>\n</div>\n\n<mat-accordion *ngIf=\"_dataSource && _dataSource.length > 0\" multi=\"true\">\n  <mat-expansion-panel\n    *ngFor=\"let row of _dataSource\"\n    [expanded]=\"row.expanded\"\n    (opened)=\"row.expanded = true\"\n    (closed)=\"row.expanded = false\"\n  >\n    <mat-expansion-panel-header>\n      <mat-panel-title>\n        <mat-checkbox\n          class=\"check-box-header\"\n          (click)=\"$event.stopPropagation()\"\n          [checked]=\"selectionHasRowValue(row) && isRowAllSelected(row)\"\n          [indeterminate]=\"selectionHasRowValue(row) && !isRowAllSelected(row)\"\n          (change)=\"$event ? toggleRow(row) : null\"\n          *ngIf=\"selectable\"\n          color=\"primary\"\n        >\n        </mat-checkbox>\n        <div class=\"header-text\" [ngClass]=\"{ selectable: selectable }\">\n          <span class=\"title uxg-subtitle-1\">{{ row.label }}</span>\n          <span class=\"subtitle uxg-body-3\">\n            <ng-container *ngTemplateOutlet=\"templateHeaderSubtitle; context: { row: row, subtitle: subtitle }\">\n            </ng-container>\n          </span>\n        </div>\n        <div class=\"header-buttons\">\n          <ng-container\n            *ngTemplateOutlet=\"templateHeaderButtons; context: { row: row, emiter: tableHeaderCallBack }\"\n          ></ng-container>\n        </div>\n      </mat-panel-title>\n    </mat-expansion-panel-header>\n    <uxg-table\n      id=\"{{ row.id }}\"\n      class=\"sub-table\"\n      [data]=\"row.values\"\n      [columns]=\"_columns\"\n      [columnsToDisplay]=\"visibleColumns\"\n      (selectChanged)=\"onTableSelectionChange($event, row)\"\n      [multiSelect]=\"selectable\"\n      [singleSelect]=\"!selectable\"\n      [selectedKeys]=\"getSelectedKeys(row)\"\n      (multiSelectSingleRowClicked)=\"onRowClicked($event)\"\n      *ngIf=\"row && row.values && _columns\"\n    >\n    </uxg-table>\n    <div class=\"table-buttons\">\n      <ng-container *ngTemplateOutlet=\"templateTableButtons; context: { row: row, emiter: tableButtonsCallBack }\">\n      </ng-container>\n    </div>\n  </mat-expansion-panel>\n</mat-accordion>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    animations: [
                        animations.trigger('detailExpand', [
                            animations.state('collapsed', animations.style({ height: '0px', minHeight: '0', padding: '0' })),
                            animations.state('expanded', animations.style({ height: '*' })),
                            animations.transition('expanded <=> collapsed', animations.animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)'))
                        ])
                    ],
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}uxg-expandable-table{width:100%;border-collapse:collapse}uxg-expandable-table .expandable-table-header{display:flex;align-items:center;padding:8px 8px 8px 24px}uxg-expandable-table .expandable-table-header .title.selectable{padding-left:16px}uxg-expandable-table .expandable-table-header .up-down{transform:rotate(90deg);margin-left:auto}uxg-expandable-table .check-box-header{margin-right:16px;display:flex}uxg-expandable-table .mat-expansion-panel{border-radius:0!important}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-header{padding-left:0}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-header .mat-expansion-panel-header-title{margin-right:0;align-items:center;padding-left:24px;min-height:48px}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-header .mat-expansion-panel-header-title .header-text{display:flex;flex-direction:column}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-header .mat-expansion-panel-header-title .header-text.selectable{padding-left:16px}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-header .mat-expansion-panel-header-title .header-text .subtitle{opacity:.8}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-header .mat-expansion-panel-header-title .header-buttons{margin-left:auto}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-header .mat-expansion-indicator{display:flex}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body{padding:0}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table{table-layout:fixed}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table .mat-header-cell .mat-checkbox{display:none}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table tr.clickable{cursor:pointer}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table.sub-table{width:100%}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table.not-selectable td.mat-cell:first-of-type,uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table.not-selectable th.mat-header-cell:first-of-type{padding-left:32px!important}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table td.mat-cell:first-of-type,uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table th.mat-header-cell:first-of-type{padding-left:24px!important}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table .mat-column-uxg-table-select-row{width:16px}uxg-expandable-table .mat-expansion-panel .mat-expansion-panel-body .mat-table .mat-column-uxg-table-select-row .check-box{display:flex}"]
                },] }
    ];
    /** @nocollapse */
    ExpandableTableComponent.ctorParameters = function () { return []; };
    ExpandableTableComponent.propDecorators = {
        dataSource: [{ type: core.Input }],
        columns: [{ type: core.Input }],
        groupByKey: [{ type: core.Input }],
        groupByKeyLabel: [{ type: core.Input }],
        subtitle: [{ type: core.Input }],
        selectable: [{ type: core.Input }],
        rowClickable: [{ type: core.Input }],
        selection: [{ type: core.Input }],
        startExpanded: [{ type: core.Input }],
        rowClick: [{ type: core.Output }],
        selectionChange: [{ type: core.Output }],
        tableButtonsCallBack: [{ type: core.Output }],
        tableHeaderCallBack: [{ type: core.Output }],
        accordion: [{ type: core.ViewChild, args: [expansion.MatAccordion, { static: false },] }],
        templateHeaderButtons: [{ type: core.ContentChild, args: ['expandableHeaderButtonsTemplate', { static: false },] }],
        templateTableButtons: [{ type: core.ContentChild, args: ['expandableTableButtonsTemplate', { static: false },] }],
        templateHeaderSubtitle: [{ type: core.ContentChild, args: ['expandableTableSubtitleTemplate', { static: false },] }]
    };

    var ExpandableTableModule = /** @class */ (function () {
        function ExpandableTableModule() {
        }
        return ExpandableTableModule;
    }());
    ExpandableTableModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [ExpandableTableComponent],
                    imports: [
                        common.CommonModule,
                        table.MatTableModule,
                        icon.MatIconModule,
                        button.MatButtonModule,
                        expansion.MatExpansionModule,
                        checkbox.MatCheckboxModule,
                        table$1.UxgTableModule
                    ],
                    exports: [ExpandableTableComponent],
                    entryComponents: [ExpandableTableComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ExpandableTableComponent = ExpandableTableComponent;
    exports.ExpandableTableModule = ExpandableTableModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-expandable-table.umd.js.map
