(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('@angular/material/button-toggle'), require('@angular/material/icon')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/filter/filter-toggle', ['exports', '@angular/common', '@angular/core', '@angular/forms', '@angular/material/button-toggle', '@angular/material/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components'].filter = global.ffdc['uxg-angular-components'].filter || {}, global.ffdc['uxg-angular-components'].filter['filter-toggle'] = {}), global.ng.common, global.ng.core, global.ng.forms, global.ng.material.buttonToggle, global.ng.material.icon));
}(this, (function (exports, common, core, forms, buttonToggle, icon) { 'use strict';

    var FilterToggleComponent = /** @class */ (function () {
        function FilterToggleComponent(hostElement) {
            this.hostElement = hostElement;
            this._data = [];
            this.showIcon = true;
            this.showLabel = true;
            this.dense = false;
            this.uxgClass = '';
            this.changes = new core.EventEmitter();
            this.hostElement.nativeElement.__component = this;
        }
        Object.defineProperty(FilterToggleComponent.prototype, "data", {
            get: function () {
                return this._data;
            },
            set: function (data) {
                this._data = data;
            },
            enumerable: false,
            configurable: true
        });
        FilterToggleComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.data.forEach(function (toggleBtn) {
                if (toggleBtn.isSelected) {
                    _this.initialValue = toggleBtn;
                    _this.selectedValue = toggleBtn;
                    _this.previousValue = toggleBtn;
                }
            });
        };
        FilterToggleComponent.prototype.onValueChange = function (val) {
            this.selectedValue = val;
            this.changes.emit({ added: [val], removed: [this.previousValue] });
            this.previousValue = val;
        };
        FilterToggleComponent.prototype.clearSelection = function () {
            this.selectedValue = undefined;
            this.changes.emit({ added: [], removed: [this.previousValue] });
        };
        FilterToggleComponent.prototype.reset = function () {
            if (this.initialValue) {
                this.selectedValue = this.initialValue;
                this.changes.emit({ added: [this.initialValue], removed: [this.previousValue] });
            }
        };
        FilterToggleComponent.prototype.getState = function () {
            return this.selectedValue ? [this.selectedValue] : [];
        };
        FilterToggleComponent.prototype.setState = function (value) {
            if (value.length) {
                this.selectedValue = value[0];
            }
        };
        return FilterToggleComponent;
    }());
    FilterToggleComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-filter-toggle',
                    template: "<mat-button-toggle-group\n  #group=\"matButtonToggleGroup\"\n  [value]=\"selectedValue\"\n  (change)=\"onValueChange(group.value)\"\n  [attr.dense]=\"dense || null\"\n  [ngClass]=\"uxgClass\"\n>\n  <ng-container *ngFor=\"let item of data\">\n    <mat-button-toggle [value]=\"item\">\n      <ng-container *ngIf=\"item.matIcon && showIcon\">\n        <mat-icon fontSet=\"material-icons-outlined\">{{ item.matIcon }}</mat-icon>\n      </ng-container>\n\n      <span *ngIf=\"showLabel\">{{ item.label }}</span>\n    </mat-button-toggle>\n  </ng-container>\n</mat-button-toggle-group>\n",
                    styles: [":host,:host .mat-button-toggle-group{width:100%}"]
                },] }
    ];
    /** @nocollapse */
    FilterToggleComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    FilterToggleComponent.propDecorators = {
        data: [{ type: core.Input }],
        showIcon: [{ type: core.Input }],
        showLabel: [{ type: core.Input }],
        dense: [{ type: core.Input }],
        uxgClass: [{ type: core.Input }],
        changes: [{ type: core.Output }]
    };

    var FilterToggleModule = /** @class */ (function () {
        function FilterToggleModule() {
        }
        return FilterToggleModule;
    }());
    FilterToggleModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [FilterToggleComponent],
                    imports: [forms.ReactiveFormsModule, common.CommonModule, buttonToggle.MatButtonToggleModule, icon.MatIconModule],
                    exports: [FilterToggleComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.FilterToggleComponent = FilterToggleComponent;
    exports.FilterToggleModule = FilterToggleModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-filter-filter-toggle.umd.js.map
