(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/router'), require('rxjs/operators'), require('rxjs'), require('@angular/material/sidenav'), require('@angular/material/toolbar'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/card'), require('@angular/material/list'), require('@ffdc/uxg-angular-components/breadcrumb')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/global-nav', ['exports', '@angular/core', '@angular/common', '@angular/router', 'rxjs/operators', 'rxjs', '@angular/material/sidenav', '@angular/material/toolbar', '@angular/material/button', '@angular/material/icon', '@angular/material/card', '@angular/material/list', '@ffdc/uxg-angular-components/breadcrumb'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['global-nav'] = {}), global.ng.core, global.ng.common, global.ng.router, global.rxjs.operators, global.rxjs, global.ng.material.sidenav, global.ng.material.toolbar, global.ng.material.button, global.ng.material.icon, global.ng.material.card, global.ng.material.list, global.ffdc['uxg-angular-components'].breadcrumb));
}(this, (function (exports, core, common, router, operators, rxjs, sidenav, toolbar, button, icon, card, list, breadcrumb) { 'use strict';

    var GlobalNavComponent = /** @class */ (function () {
        function GlobalNavComponent(router$1) {
            var _this = this;
            this.router = router$1;
            this.menuClick = new core.EventEmitter();
            this.brandAction = new core.EventEmitter();
            this.nodeChosen = new core.EventEmitter();
            this.logout = new core.EventEmitter();
            this.currentRoute = new rxjs.ReplaySubject();
            this.router.events.pipe(operators.filter(function (event) { return event instanceof router.NavigationEnd; })).subscribe(function (currentRoute) {
                var route = currentRoute.url;
                _this.currentRoute.next(route);
            });
        }
        GlobalNavComponent.prototype.ngOnInit = function () {
            var _this = this;
            if (!this.currentNode) {
                this.currentRoute.subscribe(function (currentRoute) {
                    var currentNode = _this.navigationNodes.find(function (node) { return node.path === currentRoute.replace(/\//g, ''); });
                    if (currentNode) {
                        _this.currentNode = currentNode;
                        _this.activeRoute = currentRoute;
                    }
                });
            }
        };
        GlobalNavComponent.prototype.ngOnDestroy = function () { };
        return GlobalNavComponent;
    }());
    GlobalNavComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-global-nav',
                    template: "<mat-sidenav-container class=\"uxg-nav\">\n  <mat-sidenav #globalNavDrawer mode=\"over\">\n    <uxg-sidenav\n      [appName]=\"appName\"\n      [navigationNodes]=\"navigationNodes\"\n      [activeRoute]=\"activeRoute\"\n      (nodeChosen)=\"nodeChosen.emit($event)\"\n      (logout)=\"logout.emit()\"\n    ></uxg-sidenav>\n  </mat-sidenav>\n\n  <mat-sidenav-content>\n    <uxg-navbar\n      [appName]=\"appName\"\n      [currentNode]=\"currentNode\"\n      [navbarAction]=\"navbarAction\"\n      (menuClick)=\"globalNavDrawer.toggle()\"\n      (nodeChosen)=\"nodeChosen.emit($event)\"\n      (brandAction)=\"brandAction.emit($event)\"\n    >\n    </uxg-navbar>\n\n    <div class=\"app-content\">\n      <ng-container *ngTemplateOutlet=\"appContent\"></ng-container>\n    </div>\n  </mat-sidenav-content>\n</mat-sidenav-container>\n",
                    host: {
                        class: 'uxg-global-nav'
                    },
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}mat-sidenav-container{height:100%}.mat-sidenav,mat-sidenav-container ::ng-deep .mat-drawer-backdrop{z-index:102}.uxg-toolbar{position:fixed;z-index:101}.uxg-nav-header{display:flex;flex-direction:column;align-items:center;justify-content:center}.app-content{position:absolute;top:56px;right:0;bottom:0;left:0;padding:2rem;overflow-x:auto}.theme-toggle{margin-left:16px}"]
                },] }
    ];
    /** @nocollapse */
    GlobalNavComponent.ctorParameters = function () { return [
        { type: router.Router }
    ]; };
    GlobalNavComponent.propDecorators = {
        appName: [{ type: core.Input }],
        navigationNodes: [{ type: core.Input }],
        activeRoute: [{ type: core.Input }],
        currentNode: [{ type: core.Input }],
        brandIcon: [{ type: core.Input }],
        appContent: [{ type: core.Input }],
        navbarAction: [{ type: core.Input }],
        menuClick: [{ type: core.Output }],
        brandAction: [{ type: core.Output }],
        nodeChosen: [{ type: core.Output }],
        logout: [{ type: core.Output }]
    };

    var NavbarComponent = /** @class */ (function () {
        function NavbarComponent() {
            this.breadcrumbs = [];
            this.menuClick = new core.EventEmitter();
            this.brandAction = new core.EventEmitter();
            this.nodeChosen = new core.EventEmitter();
        }
        NavbarComponent.prototype.ngOnInit = function () { };
        NavbarComponent.prototype.ngOnChanges = function (changes) {
            if (changes.currentNode) {
                this.breadcrumbs = this.buildBreadCrumb(this.appName, this.currentNode);
            }
        };
        NavbarComponent.prototype.ngOnDestroy = function () { };
        NavbarComponent.prototype.onMenuClick = function () {
            this.menuClick.emit();
        };
        NavbarComponent.prototype.buildBreadCrumb = function (appName, currentNode) {
            var breadcrumbs = [];
            if (appName) {
                breadcrumbs.push({
                    label: appName,
                    url: '/',
                    itemClass: 'uxg-h6'
                });
            }
            // Once navigation model evolve to handle deeper levels, this would need to change
            if (currentNode) {
                breadcrumbs.push({
                    label: currentNode.title,
                    url: currentNode.path
                });
            }
            return breadcrumbs;
        };
        return NavbarComponent;
    }());
    NavbarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-navbar',
                    template: "<mat-toolbar class=\"uxg-toolbar uxg-toolbar-elevated\">\n  <button\n    class=\"uxg-nav-header-button\"\n    mat-icon-button\n    mat-primary\n    color=\"primary\"\n    (click)=\"onMenuClick()\"\n    aria-label=\"Menu\"\n  >\n    <mat-icon>menu</mat-icon>\n  </button>\n\n  <a\n    href=\"javascript:void(0)\"\n    (click)=\"brandAction.emit($event)\"\n    aria-label=\"Go to Finastra website\"\n    class=\"uxg-logo\"\n    dense\n  ></a>\n\n  <uxg-breadcrumb [breadcrumbs]=\"breadcrumbs\"></uxg-breadcrumb>\n\n  <span class=\"fill-remaining-space\"></span>\n\n  <ng-container *ngTemplateOutlet=\"navbarAction\"></ng-container>\n</mat-toolbar>\n",
                    host: {
                        class: 'uxg-navbar'
                    },
                    styles: ["uxg-navbar{position:unset}.uxg-toolbar{z-index:15;position:relative}.uxg-nav-list-level.mat-nav-list.mat-list-base>.mat-list-item:last-of-type,.uxg-nav-list.mat-nav-list.mat-list-base>.mat-list-item:last-of-type{margin-bottom:0!important}.mat-list-base{padding-top:0!important}"]
                },] }
    ];
    NavbarComponent.propDecorators = {
        brandIcon: [{ type: core.Input }],
        currentNode: [{ type: core.Input }],
        navbarAction: [{ type: core.Input }],
        appName: [{ type: core.Input }],
        menuClick: [{ type: core.Output }],
        brandAction: [{ type: core.Output }],
        nodeChosen: [{ type: core.Output }]
    };

    var SidenavComponent = /** @class */ (function () {
        function SidenavComponent(_host, cd) {
            this._host = _host;
            this.cd = cd;
            this.logout = new core.EventEmitter();
            this.nodeChosen = new core.EventEmitter();
        }
        SidenavComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.iconName = this.getIconName(this.appName);
            this._host.openedChange.subscribe(function () {
                _this.currentNodes = _this.navigationNodes;
                _this.cd.markForCheck();
            });
        };
        SidenavComponent.prototype.ngOnChanges = function (changes) {
            if (changes.navigationNodes) {
                this.currentNodes = changes.navigationNodes.currentValue;
            }
        };
        SidenavComponent.prototype.getIconName = function (name) {
            if (!name)
                return name;
            var words = name.replace('-', ' ').split(' ');
            if (words && words.length === 1)
                return name;
            return !words
                ? ''
                : words
                    .map(function (word) { return word.substring(0, 1); })
                    .join('')
                    .substring(0, 3);
        };
        SidenavComponent.prototype.onClick = function (node) {
            this.nodeChosen.emit(node);
            this._host.close();
        };
        SidenavComponent.prototype.isActive = function (path) {
            if (this.activeRoute)
                return this.activeRoute.includes(path);
        };
        return SidenavComponent;
    }());
    SidenavComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-sidenav',
                    template: "<div class=\"uxg-nav-header\">\n  <mat-card class=\"uxg-card-product\" dense>\n    <span class=\"uxg-h4 uxg-card-product-name\">{{ iconName | uppercase }}</span>\n  </mat-card>\n  <h6 class=\"uxg-h6\">{{ appName | uppercase }}</h6>\n</div>\n\n<mat-nav-list class=\"uxg-nav-list-main uxg-nav-list\">\n  <div mat-subheader>Applications</div>\n  <a\n    mat-list-item\n    (click)=\"onClick(node)\"\n    [ngClass]=\"{ 'uxg-list-item-selected': isActive(node.path) }\"\n    *ngFor=\"let node of navigationNodes\"\n  >\n    <mat-icon mat-list-icon>{{ node.icon }}</mat-icon>\n    <p>{{ node.title }}</p>\n  </a>\n</mat-nav-list>\n\n<mat-nav-list class=\"uxg-link-list\">\n  <a (click)=\"logout.emit()\" mat-list-item>\n    <mat-icon mat-list-icon>power_settings_new</mat-icon>\n    <span class=\"uxg-body-2\">Logout</span>\n  </a>\n</mat-nav-list>\n",
                    styles: [":host{display:flex;flex-direction:column;height:100%}:host .uxg-nav-list-main{flex:1}:host .uxg-nav-header{display:flex;flex-direction:column;justify-content:center;align-items:center;padding:16px}:host .uxg-nav-header h6{margin-top:20px}:host mat-nav-list:last-child{margin-bottom:30px}"]
                },] }
    ];
    /** @nocollapse */
    SidenavComponent.ctorParameters = function () { return [
        { type: sidenav.MatSidenav, decorators: [{ type: core.Inject, args: [core.forwardRef(function () { return sidenav.MatSidenav; }),] }] },
        { type: core.ChangeDetectorRef }
    ]; };
    SidenavComponent.propDecorators = {
        appName: [{ type: core.Input }],
        navigationNodes: [{ type: core.Input }],
        activeRoute: [{ type: core.Input }],
        logout: [{ type: core.Output }],
        nodeChosen: [{ type: core.Output }]
    };

    var GlobalNavModule = /** @class */ (function () {
        function GlobalNavModule() {
        }
        return GlobalNavModule;
    }());
    GlobalNavModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        toolbar.MatToolbarModule,
                        button.MatButtonModule,
                        icon.MatIconModule,
                        sidenav.MatSidenavModule,
                        button.MatButtonModule,
                        card.MatCardModule,
                        list.MatListModule,
                        breadcrumb.UxgBreadcrumbModule
                    ],
                    declarations: [GlobalNavComponent, NavbarComponent, SidenavComponent],
                    exports: [GlobalNavComponent, NavbarComponent, SidenavComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.GlobalNavComponent = GlobalNavComponent;
    exports.GlobalNavModule = GlobalNavModule;
    exports.ɵa = NavbarComponent;
    exports.ɵb = SidenavComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-global-nav.umd.js.map
