(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/overlay'), require('@angular/common'), require('@angular/core'), require('@angular/flex-layout'), require('@angular/forms'), require('@angular/material/button'), require('@angular/material/checkbox'), require('@angular/material/form-field'), require('@angular/material/icon'), require('@angular/material/list'), require('@angular/material/input'), require('@angular/animations'), require('rxjs'), require('rxjs/operators'), require('@angular/cdk/portal')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/global-search', ['exports', '@angular/cdk/overlay', '@angular/common', '@angular/core', '@angular/flex-layout', '@angular/forms', '@angular/material/button', '@angular/material/checkbox', '@angular/material/form-field', '@angular/material/icon', '@angular/material/list', '@angular/material/input', '@angular/animations', 'rxjs', 'rxjs/operators', '@angular/cdk/portal'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['global-search'] = {}), global.ng.cdk.overlay, global.ng.common, global.ng.core, global.ng.flexLayout, global.ng.forms, global.ng.material.button, global.ng.material.checkbox, global.ng.material.formField, global.ng.material.icon, global.ng.material.list, global.ng.material.input, global.ng.animations, global.rxjs, global.rxjs.operators, global.ng.cdk.portal));
}(this, (function (exports, i1, common, i0, flexLayout, forms, button, checkbox, formField, icon, list, input, animations, rxjs, operators, portal) { 'use strict';

    var SearchOverlayRef = /** @class */ (function () {
        function SearchOverlayRef(overlay) {
            this.overlay = overlay;
        }
        SearchOverlayRef.prototype.close = function () {
            this.overlay.detach();
        };
        return SearchOverlayRef;
    }());

    var SEARCH_CONFIG = new i0.InjectionToken('SEARCH_CONFIG');

    var ANIMATION_TIMINGS = '300ms cubic-bezier(0.25, 0.8, 0.25, 1)';
    var GlobalSearchOverlayComponent = /** @class */ (function () {
        function GlobalSearchOverlayComponent(ref, config) {
            this.ref = ref;
            this.config = config;
            this.animationState = 'enter';
            this.results$ = new rxjs.ReplaySubject(1);
            this.resultsShown = 0;
            this.resultsFound = 0;
            this.filterSize = 0;
            this.searchValue = '';
            this.searchTime = '';
            this.resultStatusTemplate = this.config.resultStatusTemplate;
            this.emptySearchTemplate = this.config.emptySearchTemplate;
            this.resultItemTemplate = this.config.resultItemTemplate;
            this.groupBy = this.config.groupBy;
            this.showFilter = this.config.showFilter;
            this.maxItems = this.config.maxItems;
            this.itemDivider = this.config.itemDivider;
            this.groupDivider = this.config.groupDivider;
            this.itemsLayout = this.config.itemsLayout;
            this.results = this.config.results;
            this.searchTermChange = new i0.EventEmitter();
            this.itemClick = new i0.EventEmitter();
            this.searchClose = new i0.EventEmitter();
            this.searchDebounce = 300;
        }
        GlobalSearchOverlayComponent.prototype.handleKeydown = function (event) {
            this.closeSearch();
        };
        GlobalSearchOverlayComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            setTimeout(function () { return _this.searchInput.nativeElement.focus(); });
            var t0, t1;
            rxjs.fromEvent(this.searchInput.nativeElement, 'input')
                .pipe(operators.distinctUntilChanged(), operators.debounceTime(this.searchDebounce))
                .subscribe(function () {
                var value = _this.searchInput.nativeElement.value;
                _this.searchValue = value;
                _this.searchTermChange.emit(value);
                t0 = performance.now();
            });
            this.results.subscribe(function (results) {
                _this.resultsFound = _this.resultsShown = results.length;
                var groupedResults = _this.groupByResults(results, _this.groupBy);
                _this.filterSize = 0;
                _this.results$.next(groupedResults);
                t1 = performance.now();
                _this.searchTime = (t1 - t0).toLocaleString();
            });
        };
        GlobalSearchOverlayComponent.prototype.closeSearch = function () {
            this.ref.close();
            this.searchClose.emit();
        };
        GlobalSearchOverlayComponent.prototype.onItemClick = function (item) {
            this.itemClick.emit(item);
        };
        GlobalSearchOverlayComponent.prototype.toggleFilter = function (resultGroup) {
            resultGroup.selected = !resultGroup.selected;
            if (resultGroup.selected) {
                if (this.filterSize === 0) {
                    this.resultsShown = 0;
                }
                this.filterSize++;
                this.resultsShown += resultGroup.value.length;
            }
            else {
                this.filterSize--;
                if (this.filterSize === 0) {
                    this.resultsShown = this.resultsFound;
                }
                else {
                    this.resultsShown -= resultGroup.value.length;
                }
            }
            var resultsArea = document.querySelector('.uxg-global-search-results-area');
            if (resultsArea) {
                resultsArea.scrollTo(0, 0);
            }
        };
        GlobalSearchOverlayComponent.prototype.get = function (object, path, defaultVal) {
            var PATH = Array.isArray(path) ? path : path.split('.').filter(function (i) { return i.length; });
            if (!PATH.length) {
                return object === undefined ? defaultVal : object;
            }
            if (object === null || object === undefined || typeof object[PATH[0]] === 'undefined') {
                return defaultVal;
            }
            var firstPathItem = PATH.shift();
            return this.get(firstPathItem ? object[firstPathItem] : undefined, PATH, defaultVal);
        };
        GlobalSearchOverlayComponent.prototype.groupByResults = function (collection, property) {
            var _this = this;
            if (property === void 0) { property = ''; }
            if (!collection) {
                return [];
            }
            var groupedCollection = collection.reduce(function (previous, current) {
                if (!previous[_this.get(current, property || '')]) {
                    previous[_this.get(current, property)] = [current];
                }
                else {
                    previous[_this.get(current, property)].push(current);
                }
                return previous;
            }, {});
            return Object.keys(groupedCollection).map(function (key) { return ({
                key: key,
                value: groupedCollection[key]
            }); });
        };
        return GlobalSearchOverlayComponent;
    }());
    GlobalSearchOverlayComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'uxg-global-search-overlay',
                    template: "<div fxLayout=\"column\" class=\"uxg-global-search-overlay\" fxFlexFill>\n  <div fxFlex=\"5\" class=\"uxg-global-search-close-overlay-button\">\n    <button mat-icon-button (click)=\"closeSearch()\" extra-large>\n      <mat-icon>clear</mat-icon>\n    </button>\n  </div>\n  <div\n    fxFlex=\"30\"\n    fxFlex.lt-lg=\"20\"\n    fxFlex.xs=\"15\"\n    fxLayout=\"row\"\n    [@slideContent]=\"animationState\"\n    class=\"uxg-global-search-input-area\"\n  >\n    <mat-form-field floatLabel=\"never\" class=\"uxg-global-search-input\">\n      <mat-icon #searchIcon color=\"primary\" matPrefix class=\"uxg-global-search-icon\">search</mat-icon>\n      <input\n        matInput\n        #searchInput\n        type=\"search\"\n        placeholder=\"Search\"\n        autocomplete=\"off\"\n        spellcheck=\"false\"\n        aria-label=\"Global search\"\n      />\n    </mat-form-field>\n  </div>\n  <ng-container *ngIf=\"results$ | async as results; else emptySearch\">\n    <ng-container *ngIf=\"results.length; else empty\">\n      <div\n        fxFlex=\"65\"\n        fxFlex.lt-lg=\"75\"\n        fxFlex.xs=\"80\"\n        fxLayout\n        fxLayout.lt-lg=\"column\"\n        class=\"uxg-global-search-container-parent\"\n      >\n        <div\n          fxLayout=\"column\"\n          fxFlex=\"{{ showFilter ? '70' : 'auto' }}\"\n          fxFlex.lt-lg=\"auto\"\n          class=\"uxg-global-search-results-container\"\n        >\n          <!-- results status area -->\n          <ng-container [ngTemplateOutlet]=\"resultStatusTemplate\"></ng-container>\n          <div class=\"uxg-global-search-results-counter\">\n            Showing {{ resultsShown }} out of {{ resultsFound }} results\n            <span class=\"uxg-caption\">&nbsp;&nbsp;({{ searchTime }} seconds)</span>\n          </div>\n          <!-- results area -->\n          <div class=\"uxg-global-search-results-area\">\n            <ng-container *ngFor=\"let resultGroup of results\">\n              <ng-container *ngIf=\"!groupBy || (groupBy && (filterSize === 0 || (resultGroup.selected && filterSize)))\">\n                <div\n                  *ngIf=\"groupBy && resultGroup.key !== 'undefined' && resultGroup.value.length\"\n                  class=\"uxg-global-search-result-group-header\"\n                >\n                  <h4 class=\"uxg-h4\">{{ resultGroup.key }}</h4>\n                  <span class=\"uxg-global-search-result-group-counter\">({{ resultGroup.value.length }})</span>\n                </div>\n                <div class=\"uxg-global-search-result-group-container\" [fxLayout]=\"itemsLayout\">\n                  <div *ngFor=\"let result of resultGroup.value; let last = last\">\n                    <div class=\"uxg-global-search-result-item\" (click)=\"onItemClick(result)\">\n                      <ng-container\n                        *ngTemplateOutlet=\"resultItemTemplate || defaultTemplate; context: { $implicit: result }\"\n                      >\n                      </ng-container>\n                    </div>\n                    <mat-divider [inset]=\"true\" *ngIf=\"itemDivider && !last\"></mat-divider>\n                  </div>\n                </div>\n                <mat-divider *ngIf=\"groupBy && groupDivider\"></mat-divider>\n              </ng-container>\n            </ng-container>\n          </div>\n        </div>\n        <!-- filter area -->\n        <ng-container *ngIf=\"groupBy && showFilter\">\n          <mat-divider fxHide.lt-lg [vertical]=\"true\"></mat-divider>\n          <div\n            fxLayout=\"column\"\n            fxLayout.lt-lg=\"row wrap\"\n            fxFlexOrder.lt-lg=\"-1\"\n            class=\"uxg-global-search-results-filter\"\n          >\n            <h5 class=\"uxg-h5\">Filter results by</h5>\n            <ng-container *ngFor=\"let resultGroup of results\">\n              <mat-checkbox color=\"primary\" [checked]=\"resultGroup.selected\" (change)=\"toggleFilter(resultGroup)\">\n                {{ resultGroup.key }} ({{ resultGroup.value.length }})\n              </mat-checkbox>\n            </ng-container>\n          </div>\n          <mat-divider fxHide.gt-md></mat-divider>\n        </ng-container>\n      </div>\n    </ng-container>\n  </ng-container>\n</div>\n\n<ng-template #empty>\n  <ng-container *ngIf=\"searchValue.length; else emptySearch\">\n    <div fxFlex=\"5\" class=\"uxg-global-search-results-counter\">No results found</div>\n  </ng-container>\n</ng-template>\n\n<ng-template #emptySearch>\n  <ng-container *ngTemplateOutlet=\"emptySearchTemplate\"> </ng-container>\n</ng-template>\n\n<ng-template #defaultTemplate let-result>\n  <div fxLayout=\"column\">\n    <h5 class=\"uxg-subtitle-1\">{{ result.title }}</h5>\n    <div class=\"uxg-caption\">\n      {{ result.body }}\n    </div>\n  </div>\n</ng-template>\n",
                    encapsulation: i0.ViewEncapsulation.None,
                    animations: [
                        animations.trigger('slideContent', [
                            animations.state('void', animations.style({ transform: 'translate3d(0, -30%, 0) scale(0.85)', opacity: 0 })),
                            animations.state('enter', animations.style({ transform: 'none', opacity: 1 })),
                            animations.state('leave', animations.style({ transform: 'translate3d(0, -30%, 0)', opacity: 0 })),
                            animations.transition('* => *', animations.animate(ANIMATION_TIMINGS))
                        ])
                    ]
                },] }
    ];
    /** @nocollapse */
    GlobalSearchOverlayComponent.ctorParameters = function () { return [
        { type: SearchOverlayRef },
        { type: undefined, decorators: [{ type: i0.Inject, args: [SEARCH_CONFIG,] }] }
    ]; };
    GlobalSearchOverlayComponent.propDecorators = {
        resultStatusTemplate: [{ type: i0.Input }],
        emptySearchTemplate: [{ type: i0.Input }],
        resultItemTemplate: [{ type: i0.Input }],
        groupBy: [{ type: i0.Input }],
        showFilter: [{ type: i0.Input }],
        maxItems: [{ type: i0.Input }],
        itemDivider: [{ type: i0.Input }],
        groupDivider: [{ type: i0.Input }],
        itemsLayout: [{ type: i0.Input }],
        results: [{ type: i0.Input }],
        searchTermChange: [{ type: i0.Output }],
        itemClick: [{ type: i0.Output }],
        searchClose: [{ type: i0.Output }],
        searchInput: [{ type: i0.ViewChild, args: ['searchInput', { static: true },] }],
        handleKeydown: [{ type: i0.HostListener, args: ['document:keydown.escape', ['$event'],] }]
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var GlobalSearchOverlayService = /** @class */ (function () {
        function GlobalSearchOverlayService(overlay, parentInjector) {
            this.overlay = overlay;
            this.parentInjector = parentInjector;
        }
        GlobalSearchOverlayService.prototype.open = function (config) {
            var overlayRef = this.overlay.create({
                positionStrategy: this.overlay.position().global(),
                scrollStrategy: this.overlay.scrollStrategies.block(),
                hasBackdrop: true,
                backdropClass: 'uxg-global-search-overlay-backdrop',
                panelClass: 'uxg-global-search-overlay-pane'
            });
            var searchOverlayRef = new SearchOverlayRef(overlayRef);
            var injector = config ? this.getInjector(config, searchOverlayRef, this.parentInjector) : this.parentInjector;
            var containerPortal = new portal.ComponentPortal(GlobalSearchOverlayComponent, null, injector);
            var componentRef = overlayRef.attach(containerPortal);
            var element = componentRef.location.nativeElement;
            element.style.width = '100%';
            componentRef.instance.searchTermChange.subscribe(function (value) {
                if (config)
                    config.searchTermChange(value);
            });
            componentRef.instance.itemClick.subscribe(function (value) {
                if (config)
                    config.itemClick(value);
            });
            componentRef.instance.searchClose.subscribe(function (value) {
                if (config)
                    config.searchClose(value);
            });
            return [searchOverlayRef, componentRef];
        };
        GlobalSearchOverlayService.prototype.getInjector = function (config, overlayRef, parentInjector) {
            var tokens = new WeakMap();
            tokens.set(SearchOverlayRef, overlayRef);
            tokens.set(SEARCH_CONFIG, config || {});
            return new portal.PortalInjector(parentInjector, tokens);
        };
        return GlobalSearchOverlayService;
    }());
    /** @nocollapse */ GlobalSearchOverlayService.ɵprov = i0.ɵɵdefineInjectable({ factory: function GlobalSearchOverlayService_Factory() { return new GlobalSearchOverlayService(i0.ɵɵinject(i1.Overlay), i0.ɵɵinject(i0.INJECTOR)); }, token: GlobalSearchOverlayService, providedIn: "root" });
    GlobalSearchOverlayService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    GlobalSearchOverlayService.ctorParameters = function () { return [
        { type: i1.Overlay },
        { type: i0.Injector }
    ]; };

    var UxgGlobalSearch = /** @class */ (function () {
        function UxgGlobalSearch(overlayService) {
            this.overlayService = overlayService;
            this.showFilter = true;
            this.itemDivider = false;
            this.groupDivider = false;
            this.itemsLayout = 'column';
            this.results = [];
            this.resultItemClick = new i0.EventEmitter();
            this.searchTermChange = new i0.EventEmitter();
            this.searchClose = new i0.EventEmitter();
            this.results$ = new rxjs.Subject();
        }
        Object.defineProperty(UxgGlobalSearch.prototype, "searchInput", {
            get: function () {
                var _a;
                return (_a = this.componentRef) === null || _a === void 0 ? void 0 : _a.instance.searchInput;
            },
            enumerable: false,
            configurable: true
        });
        UxgGlobalSearch.prototype.openSearch = function () {
            var _b;
            var _this = this;
            _b = __read(this.overlayService.open({
                resultStatusTemplate: this.resultStatusTemplate,
                emptySearchTemplate: this.emptySearchTemplate,
                resultItemTemplate: this.resultItemTemplate,
                showFilter: this.showFilter,
                groupBy: this.groupBy,
                itemDivider: this.itemDivider,
                groupDivider: this.groupDivider,
                maxItems: this.maxItems,
                itemsLayout: this.itemsLayout,
                searchTermChange: function ($event) { return _this.searchTermChange.emit($event); },
                itemClick: function ($event) {
                    _this.resultItemClick.emit($event);
                    _this.searchClose.emit($event);
                    if (_this.ref)
                        _this.ref.close();
                },
                searchClose: function ($event) { return _this.searchClose.emit($event); },
                results: this.results$
            }), 2), this.ref = _b[0], this.componentRef = _b[1];
        };
        UxgGlobalSearch.prototype.closeSearch = function () {
            if (this.ref)
                this.ref.close();
        };
        UxgGlobalSearch.prototype.ngOnChanges = function (changes) {
            if (changes.hasOwnProperty('results') && !changes.results.firstChange) {
                this.results$.next(changes.results.currentValue);
            }
        };
        return UxgGlobalSearch;
    }());
    UxgGlobalSearch.decorators = [
        { type: i0.Component, args: [{
                    selector: 'uxg-global-search',
                    template: "<ng-content></ng-content>\n",
                    encapsulation: i0.ViewEncapsulation.None,
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}.uxg-global-search-overlay-pane{width:100%}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area{justify-content:center;align-items:center}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .uxg-global-search-input{width:50%;height:200px}@media (max-width:1279.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .uxg-global-search-input{width:65%}}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .uxg-global-search-input{width:80%}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .uxg-global-search-icon{height:99px;display:flex;align-items:center;margin-right:16px}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .uxg-global-search-icon{height:50px}}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .mat-form-field-infix{padding-bottom:0}}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .mat-form-field-infix .mat-form-field-label-wrapper{left:4px;top:.2em}}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-input-area .mat-input-element{height:50px;padding:1.5rem .2rem}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-close-overlay-button button{float:right;margin:8px;width:48px;height:48px}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-close-overlay-button button{width:32px;height:32px}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-close-overlay-button button .mat-button-wrapper{width:48px;height:48px}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-close-overlay-button button .mat-button-wrapper{width:32px;height:32px}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-close-overlay-button button .mat-button-wrapper .mat-icon{width:48px;height:48px;line-height:48px;font-size:48px}@media (min-width:0) and (max-width:599.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-close-overlay-button button .mat-button-wrapper .mat-icon{width:32px!important;height:32px!important;line-height:32px!important;font-size:32px!important}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container{overflow:hidden}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container .uxg-global-search-results-area{overflow:auto;padding:1rem 5rem 2rem;height:100%;outline:none}@media (max-width:1279.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container .uxg-global-search-results-area{padding:1rem 2rem 2rem}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container .uxg-global-search-results-area .uxg-global-search-result-group-header{display:flex;padding-top:16px}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container .uxg-global-search-results-area .uxg-global-search-result-group-header .uxg-h4{margin:0;display:flex;align-items:center}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container .uxg-global-search-results-area .uxg-global-search-result-group-header .uxg-global-search-result-group-counter{margin-left:8px}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container .uxg-global-search-results-area .uxg-global-search-result-group-container{padding-top:8px;padding-bottom:16px}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-container .uxg-global-search-results-area .uxg-global-search-result-group-container .uxg-global-search-result-item{cursor:pointer;margin:8px 16px 8px 0}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-filter{padding:0 5rem}@media (max-width:1279.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-filter{padding:1rem 2rem}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-filter .mat-checkbox{padding:4px 0}@media (max-width:1279.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-filter .mat-checkbox{margin-right:16px}}@media (max-width:1279.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent .uxg-global-search-results-filter .uxg-h5{width:100%}}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent mat-divider{margin-bottom:2rem}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-container-parent mat-divider.mat-divider-horizontal{order:-1;margin:0 2rem 16px}.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-results-counter{display:flex;align-items:center;padding-left:5rem;width:100%}@media (max-width:1279.9px){.uxg-global-search-overlay-pane uxg-global-search-overlay .uxg-global-search-results-counter{padding-left:2rem}}.uxg-global-search-overlay-pane uxg-global-search-overlay .cdk-global-scrollblock{position:static;width:auto;overflow:hidden}"]
                },] }
    ];
    /** @nocollapse */
    UxgGlobalSearch.ctorParameters = function () { return [
        { type: GlobalSearchOverlayService }
    ]; };
    UxgGlobalSearch.propDecorators = {
        groupBy: [{ type: i0.Input }],
        resultItemTemplate: [{ type: i0.Input }],
        emptySearchTemplate: [{ type: i0.Input }],
        resultStatusTemplate: [{ type: i0.Input }],
        showFilter: [{ type: i0.Input }],
        maxItems: [{ type: i0.Input }],
        itemDivider: [{ type: i0.Input }],
        groupDivider: [{ type: i0.Input }],
        itemsLayout: [{ type: i0.Input }],
        results: [{ type: i0.Input }],
        resultItemClick: [{ type: i0.Output }],
        searchTermChange: [{ type: i0.Output }],
        searchClose: [{ type: i0.Output }]
    };

    var GlobalSearchModule = /** @class */ (function () {
        function GlobalSearchModule() {
        }
        return GlobalSearchModule;
    }());
    GlobalSearchModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        button.MatButtonModule,
                        icon.MatIconModule,
                        list.MatListModule,
                        checkbox.MatCheckboxModule,
                        formField.MatFormFieldModule,
                        forms.FormsModule,
                        input.MatInputModule,
                        i1.OverlayModule,
                        flexLayout.FlexLayoutModule.withConfig({ useColumnBasisZero: false })
                    ],
                    exports: [UxgGlobalSearch, GlobalSearchOverlayComponent],
                    declarations: [UxgGlobalSearch, GlobalSearchOverlayComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.GlobalSearchModule = GlobalSearchModule;
    exports.GlobalSearchOverlayComponent = GlobalSearchOverlayComponent;
    exports.UxgGlobalSearch = UxgGlobalSearch;
    exports.ɵa = GlobalSearchOverlayService;
    exports.ɵb = SEARCH_CONFIG;
    exports.ɵc = SearchOverlayRef;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-global-search.umd.js.map
