(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material/table'), require('@angular/cdk/scrolling'), require('@angular/cdk-experimental/scrolling')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/repeater', ['exports', '@angular/core', '@angular/common', '@angular/material/table', '@angular/cdk/scrolling', '@angular/cdk-experimental/scrolling'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components'].repeater = {}), global.ng.core, global.ng.common, global.ng.material.table, global.ng.cdk.scrolling, global.ng.cdkExperimental.scrolling));
}(this, (function (exports, core, common, table, scrolling, scrolling$1) { 'use strict';

    var RepeaterComponent = /** @class */ (function () {
        function RepeaterComponent(resolver) {
            this.resolver = resolver;
            this._data = [];
            this.orientation = 'horizontal';
            this.multiSelect = false;
            this.space = '0px';
            this.columnsMatcher = {};
            this.selectedKeys = [];
            this.selectionChange = new core.EventEmitter();
            this.selectedItems = {};
        }
        Object.defineProperty(RepeaterComponent.prototype, "data", {
            get: function () {
                return this._data;
            },
            set: function (data) {
                this._data = data;
            },
            enumerable: false,
            configurable: true
        });
        RepeaterComponent.prototype.ngOnInit = function () {
            if (this.component instanceof core.Type) {
                this.componentFactory = this.resolver.resolveComponentFactory(this.component);
            }
        };
        RepeaterComponent.prototype.onClick = function (index, value) {
            var _a;
            if (!this.selectedItems) {
                this.selectedItems = {};
            }
            if (!this.multiSelect && !this.selectedItems[index]) {
                this.selectedItems = (_a = {}, _a[index] = value, _a);
            }
            else if (!this.multiSelect && this.selectedItems[index]) {
                this.selectedItems = {};
            }
            else if (this.multiSelect && this.selectedItems[index]) {
                delete this.selectedItems[index];
            }
            else {
                this.selectedItems[index] = value;
            }
            this.selectionChange.emit({ value: this.selectedItems });
        };
        RepeaterComponent.prototype.isSelected = function (index) {
            return this.selectedItems && this.selectedItems[index] !== null && this.selectedItems[index] !== undefined;
        };
        RepeaterComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes.orientation) {
                this.orientation = changes.orientation.currentValue;
            }
            if (changes.multiSelect) {
                this.multiSelect = changes.multiSelect.currentValue;
                this.selectedItems = {};
            }
            if (changes.component) {
                this.componentFactory = this.resolver.resolveComponentFactory(changes.component.currentValue);
            }
            if (changes.selectedKeys) {
                this.selectedKeys = changes.selectedKeys.currentValue;
                this.selectedItems = {};
                if (!this.multiSelect && this.selectedKeys.length > 0) {
                    this.selectedItems[this.selectedKeys[0]] = this.data[this.selectedKeys[0]];
                }
                if (this.multiSelect && this.multiSelect) {
                    this.selectedKeys.forEach(function (selectionIndex) {
                        _this.selectedItems[selectionIndex] = _this.data[selectionIndex];
                    });
                }
            }
        };
        return RepeaterComponent;
    }());
    RepeaterComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-repeater',
                    template: "<cdk-virtual-scroll-viewport autosize class=\"viewport\" [orientation]=\"orientation\">\n  <div\n    *cdkVirtualFor=\"let value of data; let odd = odd; let index = index\"\n    class=\"repeater-item\"\n    [class.alternate]=\"odd\"\n    (click)=\"onClick(index, value)\"\n  >\n    <uxg-component-repeater\n      [factory]=\"componentFactory\"\n      [data]=\"value\"\n      [columnsMatcher]=\"columnsMatcher\"\n      [ngStyle]=\"{\n        'margin-right': orientation === 'horizontal' ? space : '0px',\n        'margin-bottom': orientation === 'vertical' ? space : '0px'\n      }\"\n      [selected]=\"isSelected(index)\"\n    ></uxg-component-repeater>\n  </div>\n</cdk-virtual-scroll-viewport>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    styles: ["uxg-repeater .cdk-virtual-scroll-orientation-horizontal .cdk-virtual-scroll-content-wrapper{flex-direction:row;display:flex}uxg-repeater .repeater-item{display:flex}"]
                },] }
    ];
    /** @nocollapse */
    RepeaterComponent.ctorParameters = function () { return [
        { type: core.ComponentFactoryResolver }
    ]; };
    RepeaterComponent.propDecorators = {
        data: [{ type: core.Input }],
        component: [{ type: core.Input }],
        orientation: [{ type: core.Input }],
        multiSelect: [{ type: core.Input }],
        space: [{ type: core.Input }],
        columnsMatcher: [{ type: core.Input }],
        selectedKeys: [{ type: core.Input }],
        selectionChange: [{ type: core.Output }]
    };

    var ComponentRepeaterComponent = /** @class */ (function () {
        function ComponentRepeaterComponent() {
            this._columnsMatcher = {};
            this._selected = false;
        }
        Object.defineProperty(ComponentRepeaterComponent.prototype, "factory", {
            set: function (data) {
                this._factory = data;
                this.updateComponent();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ComponentRepeaterComponent.prototype, "data", {
            set: function (data) {
                this._data = data;
                if (this.ref) {
                    this.ref.instance.data = this._data;
                    if (this.ref.instance.cd) {
                        this.ref.instance.cd.detectChanges();
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ComponentRepeaterComponent.prototype, "columnsMatcher", {
            set: function (data) {
                this._columnsMatcher = data;
                if (this.ref) {
                    this.ref.instance.columnsMatcher = this._columnsMatcher;
                    if (this.ref.instance.cd) {
                        this.ref.instance.cd.detectChanges();
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ComponentRepeaterComponent.prototype, "selected", {
            set: function (selected) {
                this._selected = selected;
                if (this.ref) {
                    this.ref.instance.selected = this._selected;
                    if (this.ref.instance.cd) {
                        this.ref.instance.cd.detectChanges();
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        ComponentRepeaterComponent.prototype.ngOnInit = function () {
            this.updateComponent();
        };
        ComponentRepeaterComponent.prototype.updateComponent = function () {
            if (this._factory) {
                if (this.ref) {
                    this.ref.destroy();
                }
                this.ref = this.componentHolder.createComponent(this._factory);
                if (this._data) {
                    this.ref.instance.data = this._data;
                }
                if (this._columnsMatcher) {
                    this.ref.instance.columnsMatcher = this._columnsMatcher;
                }
                if (this._selected) {
                    this.ref.instance.selected = this._selected;
                }
                if (this.ref.instance.cd) {
                    this.ref.instance.cd.detectChanges();
                }
            }
        };
        return ComponentRepeaterComponent;
    }());
    ComponentRepeaterComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-component-repeater',
                    template: "<ng-container #componentHolder></ng-container>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    styles: [""]
                },] }
    ];
    /** @nocollapse */
    ComponentRepeaterComponent.ctorParameters = function () { return []; };
    ComponentRepeaterComponent.propDecorators = {
        factory: [{ type: core.Input }],
        data: [{ type: core.Input }],
        columnsMatcher: [{ type: core.Input }],
        selected: [{ type: core.Input }],
        componentHolder: [{ type: core.ViewChild, args: ['componentHolder', { read: core.ViewContainerRef, static: true },] }]
    };

    var RepeaterModule = /** @class */ (function () {
        function RepeaterModule() {
        }
        return RepeaterModule;
    }());
    RepeaterModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [RepeaterComponent, ComponentRepeaterComponent],
                    imports: [common.CommonModule, table.MatTableModule, scrolling.ScrollingModule, scrolling$1.ScrollingModule],
                    exports: [RepeaterComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ComponentRepeaterComponent = ComponentRepeaterComponent;
    exports.RepeaterComponent = RepeaterComponent;
    exports.RepeaterModule = RepeaterModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-repeater.umd.js.map
