(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/platform-browser/animations'), require('@angular/animations'), require('rxjs'), require('rxjs/operators'), require('smoothscroll-polyfill')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/scroll-to-top', ['exports', '@angular/common', '@angular/core', '@angular/material/button', '@angular/material/icon', '@angular/platform-browser/animations', '@angular/animations', 'rxjs', 'rxjs/operators', 'smoothscroll-polyfill'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['scroll-to-top'] = {}), global.ng.common, global.ng.core, global.ng.material.button, global.ng.material.icon, global.ng.platformBrowser.animations, global.ng.animations, global.rxjs, global.rxjs.operators, global.smoothscroll));
}(this, (function (exports, common, core, button, icon, animations$1, animations, rxjs, operators, smoothscroll) { 'use strict';

    var ShowStatus;
    (function (ShowStatus) {
        ShowStatus["show"] = "show";
        ShowStatus["hide"] = "hide";
    })(ShowStatus || (ShowStatus = {}));
    var ScrollToTopComponent = /** @class */ (function () {
        function ScrollToTopComponent() {
            this.showAfter = 500;
            this.showButton = false;
            this.scroll$ = rxjs.Subscription.EMPTY;
            this.state$ = new rxjs.BehaviorSubject(ShowStatus.hide);
        }
        ScrollToTopComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            smoothscroll.polyfill();
            if (this.parentElementSelector) {
                this.parent = document.querySelector(this.parentElementSelector);
            }
            else {
                this.parent = window;
            }
            this.scroll$ = rxjs.fromEvent(this.parent, 'scroll')
                .pipe(operators.throttleTime(10), operators.map(function () { return _this.parent.pageYOffset || _this.parent.scrollTop; }), operators.map(function (y) {
                if (y > _this.showAfter) {
                    return ShowStatus.show;
                }
                else {
                    return ShowStatus.hide;
                }
            }), operators.distinctUntilChanged(), operators.share())
                .subscribe(function (s) { return _this.state$.next(s); });
        };
        ScrollToTopComponent.prototype.ngOnDestroy = function () {
            this.scroll$.unsubscribe();
        };
        ScrollToTopComponent.prototype.onClick = function () {
            this.parent.scroll({ top: 0, left: 0, behavior: 'smooth' });
        };
        return ScrollToTopComponent;
    }());
    ScrollToTopComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-scroll-to-top',
                    template: "<div class=\"scroll-to-top-container\" (click)=\"onClick()\" [@scrollAnimation]=\"state$ | async\">\n  <ng-container *ngTemplateOutlet=\"customTemplate || defaultTemplate\"> </ng-container>\n</div>\n\n<ng-template #defaultTemplate>\n  <button mat-fab color=\"gradient\" aria-label=\"Scroll to top\">\n    <mat-icon>keyboard_arrow_up</mat-icon>\n  </button>\n</ng-template>\n",
                    animations: [
                        animations.trigger('scrollAnimation', [
                            animations.state('show', animations.style({ opacity: 1, transform: 'scale(1)' })),
                            animations.state('hide', animations.style({ opacity: 0, transform: 'scale(0)' })),
                            animations.transition('show => hide', animations.animate('350ms ease-out')),
                            animations.transition('hide => show', animations.animate('350ms ease-in'))
                        ])
                    ],
                    styles: [":host{position:fixed;z-index:5;right:20px;bottom:50px}"]
                },] }
    ];
    /** @nocollapse */
    ScrollToTopComponent.ctorParameters = function () { return []; };
    ScrollToTopComponent.propDecorators = {
        customTemplate: [{ type: core.Input }],
        showAfter: [{ type: core.Input }],
        parentElementSelector: [{ type: core.Input }]
    };

    var ScrollToTopModule = /** @class */ (function () {
        function ScrollToTopModule() {
        }
        return ScrollToTopModule;
    }());
    ScrollToTopModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, button.MatButtonModule, icon.MatIconModule, animations$1.BrowserAnimationsModule],
                    declarations: [ScrollToTopComponent],
                    exports: [ScrollToTopComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ScrollToTopComponent = ScrollToTopComponent;
    exports.ScrollToTopModule = ScrollToTopModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-scroll-to-top.umd.js.map
