(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/animations'), require('@angular/common'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/material/icon'), require('@angular/material/button')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/search-input', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/animations', '@angular/common', '@angular/material/form-field', '@angular/material/input', '@angular/material/icon', '@angular/material/button'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['search-input'] = {}), global.ng.core, global.rxjs, global.rxjs.operators, global.ng.animations, global.ng.common, global.ng.material.formField, global.ng.material.input, global.ng.material.icon, global.ng.material.button));
}(this, (function (exports, core, rxjs, operators, animations, common, formField, input, icon, button) { 'use strict';

    var UxgSearchInputComponent = /** @class */ (function () {
        function UxgSearchInputComponent(dense) {
            var _this = this;
            this.dense = dense;
            this.query = '';
            this.placeholder = 'Search';
            this.debounceTime = 400;
            this.search = new core.EventEmitter();
            this.term$ = new rxjs.Subject();
            this.termSubscription = this.term$
                .pipe(operators.debounceTime(this.debounceTime), operators.distinctUntilChanged())
                .subscribe(function (query) {
                _this.search.emit(query);
            });
        }
        UxgSearchInputComponent.prototype.ngOnDestroy = function () {
            this.termSubscription.unsubscribe();
        };
        return UxgSearchInputComponent;
    }());
    UxgSearchInputComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-search-input',
                    template: "<mat-form-field appearance=\"fill\" [attr.dense]=\"dense === '' ? '' : null\">\n  <mat-icon color=\"primary\" matPrefix>search</mat-icon>\n  <input\n    #searchInput=\"matInput\"\n    matInput\n    type=\"text\"\n    placeholder=\"{{ placeholder }}\"\n    [value]=\"query\"\n    (input)=\"term$.next($event.target.value)\"\n    aria-label=\"Search input\"\n  />\n  <button\n    [@showHide]=\"searchInput.value ? 'show' : 'hide'\"\n    (click)=\"searchInput.value = ''; term$.next('')\"\n    matSuffix\n    mat-icon-button\n    aria-label=\"Clear\"\n  >\n    <mat-icon>clear</mat-icon>\n  </button>\n  <mat-hint *ngIf=\"hint\">{{ hint }}</mat-hint>\n</mat-form-field>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        class: 'uxg-search-input'
                    },
                    animations: [
                        animations.trigger('showHide', [
                            animations.state('show', animations.style({
                                opacity: 1,
                                visibility: 'visible'
                            })),
                            animations.state('hide', animations.style({
                                opacity: 0,
                                visibility: 'hidden'
                            })),
                            animations.transition('show => hide', [animations.animate('0.3s ease-out')]),
                            animations.transition('hide => show', [animations.animate('0.2s ease-in')])
                        ])
                    ],
                    styles: [".uxg-search-input{display:flex}.uxg-search-input .mat-form-field{flex:1}"]
                },] }
    ];
    /** @nocollapse */
    UxgSearchInputComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Attribute, args: ['dense',] }] }
    ]; };
    UxgSearchInputComponent.propDecorators = {
        query: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        debounceTime: [{ type: core.Input }],
        hint: [{ type: core.Input }],
        search: [{ type: core.Output }]
    };

    var UxgSearchInputModule = /** @class */ (function () {
        function UxgSearchInputModule() {
        }
        return UxgSearchInputModule;
    }());
    UxgSearchInputModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, formField.MatFormFieldModule, input.MatInputModule, icon.MatIconModule, button.MatButtonModule],
                    exports: [UxgSearchInputComponent],
                    declarations: [UxgSearchInputComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.UxgSearchInputComponent = UxgSearchInputComponent;
    exports.UxgSearchInputModule = UxgSearchInputModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-search-input.umd.js.map
