(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/overlay'), require('@angular/cdk/portal'), require('@angular/common'), require('@angular/animations'), require('@angular/flex-layout'), require('@angular/material/icon'), require('@angular/material/button')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/toaster', ['exports', '@angular/core', '@angular/cdk/overlay', '@angular/cdk/portal', '@angular/common', '@angular/animations', '@angular/flex-layout', '@angular/material/icon', '@angular/material/button'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components'].toaster = {}), global.ng.core, global.ng.cdk.overlay, global.ng.cdk.portal, global.ng.common, global.ng.animations, global.ng.flexLayout, global.ng.material.icon, global.ng.material.button));
}(this, (function (exports, i0, overlay, portal, common, animations, flexLayout, icon, button) { 'use strict';

    var Toast = /** @class */ (function () {
        function Toast() {
        }
        return Toast;
    }());
    (function (ToastType) {
        ToastType["SUCCESS"] = "success";
        ToastType["ERROR"] = "error";
        ToastType["WARNING"] = "warning";
        ToastType["INFO"] = "info";
    })(exports.ToastType || (exports.ToastType = {}));
    (function (ToastLogicalPosition) {
        ToastLogicalPosition["TOP_START"] = "top-start";
        ToastLogicalPosition["TOP_END"] = "top-end";
        ToastLogicalPosition["BOTTOM_START"] = "bottom-start";
        ToastLogicalPosition["BOTTOM_END"] = "bottom-end";
    })(exports.ToastLogicalPosition || (exports.ToastLogicalPosition = {}));
    (function (ToastPhysicalPosition) {
        ToastPhysicalPosition["TOP_RIGHT"] = "top-right";
        ToastPhysicalPosition["TOP_LEFT"] = "top-left";
        ToastPhysicalPosition["BOTTOM_RIGHT"] = "bottom-right";
        ToastPhysicalPosition["BOTTOM_LEFT"] = "bottom-left";
    })(exports.ToastPhysicalPosition || (exports.ToastPhysicalPosition = {}));

    var TOASTER_CONFIG = new i0.InjectionToken('Default toaster config');
    var ToasterConfig = /** @class */ (function () {
        function ToasterConfig(config) {
            /**
             * Status chooses color scheme for the toast.
             * */
            this.type = 'info';
            /**
             * Duration is timeout between toast appears and disappears. 0 keeps the toast indefinitely on the screen
             * */
            this.duration = 5000;
            /**
             * Determines where on the screen toast have to be rendered.
             * */
            this.position = exports.ToastLogicalPosition.TOP_END;
            /**
             * Destroy by click means you can hide the toast by clicking it.
             * */
            this.destroyByClick = true;
            Object.assign(this, config);
        }
        return ToasterConfig;
    }());

    var ToasterComponent = /** @class */ (function () {
        function ToasterComponent() {
            this.destroy = new i0.EventEmitter();
        }
        Object.defineProperty(ToasterComponent.prototype, "success", {
            get: function () {
                return this.toast.config.type === 'success';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ToasterComponent.prototype, "info", {
            get: function () {
                return this.toast.config.type === 'info';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ToasterComponent.prototype, "warning", {
            get: function () {
                return this.toast.config.type === 'warning';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ToasterComponent.prototype, "primary", {
            get: function () {
                return this.toast.config.type === 'error';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ToasterComponent.prototype, "destroyByClick", {
            get: function () {
                return this.toast.config.destroyByClick;
            },
            enumerable: false,
            configurable: true
        });
        ToasterComponent.prototype.onClick = function () {
            this.destroy.emit();
        };
        return ToasterComponent;
    }());
    ToasterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'uxg-toaster',
                    template: "<div fxLayoutAlign=\"center center\" class=\"icon-container\">\n  <mat-icon dense *ngIf=\"toast.config.type === 'success'\">check_circle_outline</mat-icon>\n  <mat-icon dense *ngIf=\"toast.config.type === 'error'\">error_outline</mat-icon>\n  <mat-icon class=\"material-icons-outlined\" dense *ngIf=\"toast.config.type === 'warning'\">report_problem</mat-icon>\n  <mat-icon class=\"material-icons-outlined\" dense *ngIf=\"toast.config.type === 'info'\">info</mat-icon>\n</div>\n<div fxFlex fxFlexAlign=\"center\" class=\"uxg-body-2 message\">\n  {{ toast.message }}\n</div>\n",
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}:host{margin:16px 4vw;min-height:48px;width:92vw;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}:host .icon-container{width:48px;border-radius:4px 0 0 4px;padding:16px}:host .message{padding:16px;word-break:break-word;white-space:pre-line}:host.destroy-by-click{cursor:pointer}@media only screen and (min-width:600px) and (max-width:719px){:host{width:50vw;margin:16px}}@media only screen and (min-width:720px){:host{width:30vw;margin:16px}}"]
                },] }
    ];
    ToasterComponent.propDecorators = {
        toast: [{ type: i0.Input }],
        destroy: [{ type: i0.Output }],
        success: [{ type: i0.HostBinding, args: ['class.type-success',] }],
        info: [{ type: i0.HostBinding, args: ['class.type-info',] }],
        warning: [{ type: i0.HostBinding, args: ['class.type-warning',] }],
        primary: [{ type: i0.HostBinding, args: ['class.type-error',] }],
        destroyByClick: [{ type: i0.HostBinding, args: ['class.destroy-by-click',] }],
        onClick: [{ type: i0.HostListener, args: ['click',] }]
    };

    var voidState = animations.style({
        transform: 'translateX(110%)',
        height: 0,
        marginLeft: '0',
        marginRight: '0'
    });
    var ToasterContainerComponent = /** @class */ (function () {
        function ToasterContainerComponent() {
            this.content = [];
        }
        ToasterContainerComponent.prototype.ngOnInit = function () { };
        ToasterContainerComponent.prototype.ngOnDestroy = function () { };
        return ToasterContainerComponent;
    }());
    ToasterContainerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'uxg-toaster-container',
                    template: "\n    <uxg-toaster\n      fxLayout=\"row\"\n      fxLayoutAlign=\"start stretch\"\n      [@fadeIn]=\"fadeIn\"\n      *ngFor=\"let toast of content\"\n      [toast]=\"toast\"\n    ></uxg-toaster>\n  ",
                    animations: [
                        animations.trigger('fadeIn', [
                            animations.transition(':enter', [voidState, animations.animate(100)]),
                            animations.transition(':leave', [animations.animate(100, voidState)])
                        ])
                    ]
                },] }
    ];
    /** @nocollapse */
    ToasterContainerComponent.ctorParameters = function () { return []; };
    ToasterContainerComponent.propDecorators = {
        content: [{ type: i0.Input }],
        toasts: [{ type: i0.ViewChildren, args: [ToasterComponent,] }]
    };

    var ToasterRef = /** @class */ (function () {
        function ToasterRef(toasterContainer, toast) {
            this.toasterContainer = toasterContainer;
            this.toast = toast;
        }
        ToasterRef.prototype.close = function () {
            this.toasterContainer.destroy(this.toast);
        };
        return ToasterRef;
    }());
    var ToasterContainerOverlayService = /** @class */ (function () {
        function ToasterContainerOverlayService(overlay) {
            this.overlay = overlay;
        }
        Object.defineProperty(ToasterContainerOverlayService.prototype, "scrollStrategies", {
            get: function () {
                return this.overlay.scrollStrategies;
            },
            enumerable: false,
            configurable: true
        });
        ToasterContainerOverlayService.prototype.create = function (config) {
            // Returns an OverlayRef (which is a PortalHost)
            return this.overlay.create(Object.assign(Object.assign({}, config), { panelClass: 'uxg-toaster-overlay' }));
        };
        return ToasterContainerOverlayService;
    }());
    ToasterContainerOverlayService.decorators = [
        { type: i0.Injectable }
    ];
    /** @nocollapse */
    ToasterContainerOverlayService.ctorParameters = function () { return [
        { type: overlay.Overlay }
    ]; };
    var ToasterContainer = /** @class */ (function () {
        function ToasterContainer(position, containerRef) {
            this.position = position;
            this.containerRef = containerRef;
            this.toasts = [];
        }
        Object.defineProperty(ToasterContainer.prototype, "nativeElement", {
            get: function () {
                return this.containerRef.location.nativeElement;
            },
            enumerable: false,
            configurable: true
        });
        ToasterContainer.prototype.attach = function (toast) {
            var toastComponent = this.attachToast(toast);
            if (toast.config.destroyByClick) {
                this.subscribeOnClick(toastComponent, toast);
            }
            if (toast.config.duration) {
                this.setDestroyTimeout(toast);
            }
            this.prevToast = toast;
            return new ToasterRef(this, toast);
        };
        ToasterContainer.prototype.destroy = function (toast) {
            if (this.prevToast === toast) {
                this.prevToast = null;
            }
            this.toasts = this.toasts.filter(function (t) { return t !== toast; });
            this.updateContainer();
        };
        ToasterContainer.prototype.attachToast = function (toast) {
            return this.attachToTop(toast);
        };
        ToasterContainer.prototype.attachToTop = function (toast) {
            this.toasts.unshift(toast);
            this.updateContainer();
            return this.containerRef.instance.toasts.first;
        };
        ToasterContainer.prototype.setDestroyTimeout = function (toast) {
            var _this = this;
            setTimeout(function () { return _this.destroy(toast); }, toast.config.duration);
        };
        ToasterContainer.prototype.subscribeOnClick = function (toastComponent, toast) {
            var _this = this;
            toastComponent.destroy.subscribe(function () { return _this.destroy(toast); });
        };
        ToasterContainer.prototype.updateContainer = function () {
            patch(this.containerRef, { content: this.toasts, position: this.position });
        };
        return ToasterContainer;
    }());
    function patch(container, containerContext) {
        Object.assign(container.instance, containerContext);
        container.changeDetectorRef.detectChanges();
        return container;
    }
    var ToasterContainerRegistry = /** @class */ (function () {
        function ToasterContainerRegistry(overlay, overlayService, cfr, document) {
            this.overlay = overlay;
            this.overlayService = overlayService;
            this.cfr = cfr;
            this.document = document;
            this.overlays = new Map();
        }
        ToasterContainerRegistry.prototype.get = function (position) {
            var logicalPosition = this.toLogicalPosition(position);
            var overlayWithContainer = this.overlays.get(position);
            if (!overlayWithContainer || !this.existsInDom(overlayWithContainer.toasterContainer)) {
                if (overlayWithContainer) {
                    overlayWithContainer.overlayRef.dispose();
                }
                this.instantiateContainer(logicalPosition);
            }
            return this.overlays.get(logicalPosition).toasterContainer;
        };
        ToasterContainerRegistry.prototype.instantiateContainer = function (position) {
            var toasterOverlayWithContainer = this.createContainer(position);
            this.overlays.set(position, toasterOverlayWithContainer);
        };
        ToasterContainerRegistry.prototype.createContainer = function (position) {
            var positionStrategy = this.overlay.position().global().top().right(); // TODO - add customizable positioning. hardcoded to top-right for now
            var ref = this.overlayService.create({ positionStrategy: positionStrategy });
            ref.hostElement.setAttribute('class', 'uxg-toaster-overlay-wrapper');
            var containerRef = ref.attach(new portal.ComponentPortal(ToasterContainerComponent, null, null, this.cfr));
            return {
                overlayRef: ref,
                toasterContainer: new ToasterContainer(position, containerRef)
            };
        };
        ToasterContainerRegistry.prototype.existsInDom = function (toastContainer) {
            return this.document.body.contains(toastContainer.nativeElement);
        };
        ToasterContainerRegistry.prototype.toLogicalPosition = function (position) {
            if (Object.values(exports.ToastLogicalPosition).includes(position)) {
                return position;
            }
            return exports.ToastLogicalPosition.TOP_START; // TODO - remove when handling positioning
        };
        return ToasterContainerRegistry;
    }());
    ToasterContainerRegistry.decorators = [
        { type: i0.Injectable }
    ];
    /** @nocollapse */
    ToasterContainerRegistry.ctorParameters = function () { return [
        { type: overlay.Overlay },
        { type: ToasterContainerOverlayService },
        { type: i0.ComponentFactoryResolver },
        { type: undefined, decorators: [{ type: i0.Inject, args: [common.DOCUMENT,] }] }
    ]; };
    /**
     * The `ToasterService` provides a capability to build toast notifications.
     *
     * `ToasterService.show(message, config)` accepts two params, config is optional.
     *
     * ### Import
     *
     * Import `ToasterModule` to your app module.
     * ```ts
     * @NgModule({
     *   imports: [
     *     // ...
     *     ToasterModule,
     *   ],
     * })
     * export class AppModule { }
     * ```
     *
     * ### Usage
     *
     * Calling `ToasterService.show(...)` will render new toast and return `ToasterRef` with
     * help of which you may close newly created toast by calling `close` method.
     *
     * ```ts
     * const toastRef: ToasterRef = this.toasterService.show(...);
     * toastRef.close();
     * ```
     *
     * Config accepts following options:
     *
     * `type` - coloring and icon of the toast.
     * Default is `info`.
     *
     * `duration` - the time after which the toast will be destroyed.
     * `0` means endless toast, that may be destroyed by click only.
     * Default is 3000 ms.
     *
     * `position` - determines where on the screen toast will be rendered.
     * Default is `top-end`, hardcoded for now.
     *
     * `destroyByClick` - provides a capability to destroy toast by click.
     * Default is true.
     * */
    var ToasterService = /** @class */ (function () {
        function ToasterService(globalConfig, containerRegistry) {
            this.globalConfig = globalConfig;
            this.containerRegistry = containerRegistry;
        }
        /**
         * Shows toast with message and user config.
         * */
        ToasterService.prototype.show = function (message, userConfig) {
            var config = new ToasterConfig(Object.assign(Object.assign({}, this.globalConfig), userConfig));
            var container = this.containerRegistry.get(config.position);
            var toast = { message: message, config: config };
            return container.attach(toast);
        };
        /**
         * Shows success toast with message, title and user config.
         * */
        ToasterService.prototype.success = function (message, config) {
            return this.show(message, Object.assign(Object.assign({}, config), { type: exports.ToastType.SUCCESS }));
        };
        /**
         * Shows error toast with message, title and user config.
         * */
        ToasterService.prototype.error = function (message, config) {
            return this.show(message, Object.assign(Object.assign({}, config), { type: exports.ToastType.ERROR }));
        };
        /**
         * Shows warning toast with message, title and user config.
         * */
        ToasterService.prototype.warning = function (message, config) {
            return this.show(message, Object.assign(Object.assign({}, config), { type: exports.ToastType.WARNING }));
        };
        /**
         * Shows info toast with message, title and user config.
         * */
        ToasterService.prototype.info = function (message, config) {
            return this.show(message, Object.assign(Object.assign({}, config), { type: exports.ToastType.INFO }));
        };
        return ToasterService;
    }());
    /** @nocollapse */ ToasterService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ToasterService_Factory() { return new ToasterService(i0.ɵɵinject(TOASTER_CONFIG), i0.ɵɵinject(ToasterContainerRegistry)); }, token: ToasterService, providedIn: "root" });
    ToasterService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ToasterService.ctorParameters = function () { return [
        { type: ToasterConfig, decorators: [{ type: i0.Inject, args: [TOASTER_CONFIG,] }] },
        { type: ToasterContainerRegistry }
    ]; };

    var ɵ0 = {};
    var ToasterModule = /** @class */ (function () {
        function ToasterModule() {
        }
        return ToasterModule;
    }());
    ToasterModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, icon.MatIconModule, button.MatButtonModule, flexLayout.FlexLayoutModule],
                    declarations: [ToasterContainerComponent, ToasterComponent],
                    providers: [
                        ToasterService,
                        ToasterContainerOverlayService,
                        ToasterContainerRegistry,
                        { provide: TOASTER_CONFIG, useValue: ɵ0 }
                    ],
                    exports: [ToasterComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.TOASTER_CONFIG = TOASTER_CONFIG;
    exports.Toast = Toast;
    exports.ToasterComponent = ToasterComponent;
    exports.ToasterConfig = ToasterConfig;
    exports.ToasterContainer = ToasterContainer;
    exports.ToasterContainerComponent = ToasterContainerComponent;
    exports.ToasterContainerOverlayService = ToasterContainerOverlayService;
    exports.ToasterContainerRegistry = ToasterContainerRegistry;
    exports.ToasterModule = ToasterModule;
    exports.ToasterRef = ToasterRef;
    exports.ToasterService = ToasterService;
    exports.patch = patch;
    exports.ɵ0 = ɵ0;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-toaster.umd.js.map
