(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/menu'), require('@angular/common'), require('@angular/material/divider'), require('@ffdc/uxg-angular-components/avatar')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/user-profile-menu', ['exports', '@angular/core', '@angular/material/menu', '@angular/common', '@angular/material/divider', '@ffdc/uxg-angular-components/avatar'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['user-profile-menu'] = {}), global.ng.core, global.ng.material.menu, global.ng.common, global.ng.material.divider, global.ffdc['uxg-angular-components'].avatar));
}(this, (function (exports, core, menu, common, divider, avatar) { 'use strict';

    var UxgUserProfilePanelActionsDirective = /** @class */ (function () {
        function UxgUserProfilePanelActionsDirective() {
        }
        return UxgUserProfilePanelActionsDirective;
    }());
    UxgUserProfilePanelActionsDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[uxg-user-profile-panel-actions], [uxgUserProfilePanelActions]' },] }
    ];
    /** @nocollapse */
    UxgUserProfilePanelActionsDirective.ctorParameters = function () { return []; };

    var UxgUserProfilePanelContentDirective = /** @class */ (function () {
        function UxgUserProfilePanelContentDirective() {
        }
        return UxgUserProfilePanelContentDirective;
    }());
    UxgUserProfilePanelContentDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[uxg-user-profile-panel-content], [uxgUserProfilePanelContent]' },] }
    ];
    /** @nocollapse */
    UxgUserProfilePanelContentDirective.ctorParameters = function () { return []; };

    var UxgUserProfilePanelDetailsDirective = /** @class */ (function () {
        function UxgUserProfilePanelDetailsDirective() {
        }
        return UxgUserProfilePanelDetailsDirective;
    }());
    UxgUserProfilePanelDetailsDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[uxg-user-profile-panel-details], [uxgUserProfilePanelDetails]' },] }
    ];
    /** @nocollapse */
    UxgUserProfilePanelDetailsDirective.ctorParameters = function () { return []; };

    var UxgUserProfileMenuComponent = /** @class */ (function () {
        function UxgUserProfileMenuComponent(dense) {
            this.dense = dense;
            this.color = 'gradient';
            this.headerType = 'title';
        }
        return UxgUserProfileMenuComponent;
    }());
    UxgUserProfileMenuComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-user-profile-menu',
                    template: "<uxg-avatar\n  [dense]=\"dense === '' ? true : false\"\n  [color]=\"color\"\n  [name]=\"user.username\"\n  [defaultGravatar]=\"defaultGravatar\"\n  [gravatarEmail]=\"user.gravatarEmail\"\n  [matMenuTriggerFor]=\"menuUserProfile\"\n  [avatarImage]=\"user.photo ? avatarImage : null\"\n>\n</uxg-avatar>\n<mat-menu #menuUserProfile class=\"uxg-user-profile\">\n  <uxg-user-profile-panel\n    [user]=\"user\"\n    [defaultGravatar]=\"defaultGravatar\"\n    [color]=\"color\"\n    [headerType]=\"headerType\"\n    [contentTemplate]=\"uxgUserProfilePanelContent\"\n    [actionsTemplate]=\"uxgUserProfilePanelActions\"\n    [detailsTemplate]=\"uxgUserProfilePanelDetails\"\n  >\n  </uxg-user-profile-panel>\n</mat-menu>\n\n<ng-template #avatarImage>\n  <img [src]=\"user.photo\" />\n</ng-template>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        class: 'uxg-user-profile-menu'
                    },
                    styles: [".uxg-user-profile-menu .uxg-avatar{cursor:pointer}"]
                },] }
    ];
    /** @nocollapse */
    UxgUserProfileMenuComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Attribute, args: ['dense',] }] }
    ]; };
    UxgUserProfileMenuComponent.propDecorators = {
        user: [{ type: core.Input }],
        defaultGravatar: [{ type: core.Input }],
        color: [{ type: core.Input }],
        headerType: [{ type: core.Input }],
        avatarImage: [{ type: core.ViewChild, args: ['avatarImage', { read: core.TemplateRef, static: true },] }],
        userMenuTrigger: [{ type: core.ViewChild, args: [menu.MatMenuTrigger, { static: true },] }],
        uxgUserProfilePanelContent: [{ type: core.ContentChild, args: [UxgUserProfilePanelContentDirective, { read: core.TemplateRef, static: true },] }],
        uxgUserProfilePanelActions: [{ type: core.ContentChild, args: [UxgUserProfilePanelActionsDirective, { read: core.TemplateRef, static: true },] }],
        uxgUserProfilePanelDetails: [{ type: core.ContentChild, args: [UxgUserProfilePanelDetailsDirective, { read: core.TemplateRef, static: true },] }]
    };

    var UxgUserProfilePanelComponent = /** @class */ (function () {
        function UxgUserProfilePanelComponent() {
            this.color = 'gradient';
            this.headerType = 'title';
            this.hasContent = false;
            this.hasFooter = false;
            this.hasDetails = false;
        }
        UxgUserProfilePanelComponent.prototype.ngAfterContentInit = function () {
            this.hasContent = !!this.uxgUserProfilePanelContent || !!this.contentTemplate;
            this.hasFooter = !!this.uxgUserProfilePanelActions || !!this.actionsTemplate;
            this.hasDetails = !!this.uxgUserProfilePanelDetails || !!this.detailsTemplate;
        };
        return UxgUserProfilePanelComponent;
    }());
    UxgUserProfilePanelComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-user-profile-panel',
                    template: "<div class=\"uxg-menu-header\">\n  <div\n    [ngClass]=\"{\n      'uxg-avatar-hero-block': headerType === 'hero',\n      'uxg-avatar-title-block': headerType === 'title'\n    }\"\n  >\n    <uxg-avatar\n      [attr.large]=\"headerType === 'title' ? null : true\"\n      [name]=\"user.username\"\n      [defaultGravatar]=\"defaultGravatar\"\n      [color]=\"color\"\n      [gravatarEmail]=\"user.gravatarEmail\"\n      [avatarImage]=\"user.photo ? avatarImage : null\"\n    >\n    </uxg-avatar>\n    <h6 class=\"uxg-h6\">{{ user.username }}</h6>\n    <div class=\"uxg-caption\">{{ user.email }}</div>\n\n    <ng-container *ngIf=\"hasDetails\">\n      <div>\n        <ng-container *ngTemplateOutlet=\"uxgUserProfilePanelDetails || detailsTemplate\"></ng-container>\n      </div>\n    </ng-container>\n  </div>\n</div>\n\n<ng-container *ngIf=\"hasContent\">\n  <mat-divider></mat-divider>\n  <div>\n    <ng-container *ngTemplateOutlet=\"uxgUserProfilePanelContent || contentTemplate\"></ng-container>\n  </div>\n</ng-container>\n\n<ng-container *ngIf=\"hasFooter\">\n  <mat-divider></mat-divider>\n  <div [ngClass]=\"{ 'uxg-menu-footer': hasFooter }\">\n    <ng-container *ngTemplateOutlet=\"uxgUserProfilePanelActions || actionsTemplate\"></ng-container>\n  </div>\n</ng-container>\n\n<ng-template #avatarImage>\n  <img [src]=\"user.photo\" />\n</ng-template>\n",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    host: {
                        class: 'uxg-user-profile-panel',
                        '[class.has-content]': 'hasContent'
                    }
                },] }
    ];
    /** @nocollapse */
    UxgUserProfilePanelComponent.ctorParameters = function () { return []; };
    UxgUserProfilePanelComponent.propDecorators = {
        user: [{ type: core.Input }],
        defaultGravatar: [{ type: core.Input }],
        color: [{ type: core.Input }],
        headerType: [{ type: core.Input }],
        contentTemplate: [{ type: core.Input }],
        actionsTemplate: [{ type: core.Input }],
        detailsTemplate: [{ type: core.Input }],
        avatarImage: [{ type: core.ViewChild, args: ['avatarImage', { read: core.TemplateRef, static: true },] }],
        uxgUserProfilePanelContent: [{ type: core.ContentChild, args: [UxgUserProfilePanelContentDirective, { read: core.TemplateRef, static: true },] }],
        uxgUserProfilePanelActions: [{ type: core.ContentChild, args: [UxgUserProfilePanelActionsDirective, { read: core.TemplateRef, static: true },] }],
        uxgUserProfilePanelDetails: [{ type: core.ContentChild, args: [UxgUserProfilePanelDetailsDirective, { read: core.TemplateRef, static: true },] }]
    };

    var UxgUserProfileMenuModule = /** @class */ (function () {
        function UxgUserProfileMenuModule() {
        }
        return UxgUserProfileMenuModule;
    }());
    UxgUserProfileMenuModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, avatar.AvatarModule, divider.MatDividerModule, menu.MatMenuModule],
                    exports: [
                        UxgUserProfileMenuComponent,
                        UxgUserProfilePanelComponent,
                        UxgUserProfilePanelActionsDirective,
                        UxgUserProfilePanelContentDirective,
                        UxgUserProfilePanelDetailsDirective
                    ],
                    declarations: [
                        UxgUserProfilePanelComponent,
                        UxgUserProfileMenuComponent,
                        UxgUserProfilePanelActionsDirective,
                        UxgUserProfilePanelContentDirective,
                        UxgUserProfilePanelDetailsDirective
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.UxgUserProfileMenuComponent = UxgUserProfileMenuComponent;
    exports.UxgUserProfileMenuModule = UxgUserProfileMenuModule;
    exports.UxgUserProfilePanelActionsDirective = UxgUserProfilePanelActionsDirective;
    exports.UxgUserProfilePanelComponent = UxgUserProfilePanelComponent;
    exports.UxgUserProfilePanelContentDirective = UxgUserProfilePanelContentDirective;
    exports.UxgUserProfilePanelDetailsDirective = UxgUserProfilePanelDetailsDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-user-profile-menu.umd.js.map
