(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/material/icon')) :
    typeof define === 'function' && define.amd ? define('@ffdc/uxg-angular-components/video-thumbnail', ['exports', '@angular/common', '@angular/core', '@angular/material/icon'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.ffdc = global.ffdc || {}, global.ffdc['uxg-angular-components'] = global.ffdc['uxg-angular-components'] || {}, global.ffdc['uxg-angular-components']['video-thumbnail'] = {}), global.ng.common, global.ng.core, global.ng.material.icon));
}(this, (function (exports, common, core, icon) { 'use strict';

    var VideoThumbnailComponent = /** @class */ (function () {
        function VideoThumbnailComponent(dense, large) {
            this.dense = dense;
            this.large = large;
            this.videoClick = new core.EventEmitter();
        }
        VideoThumbnailComponent.prototype.onVideoClick = function (video, $event) {
            this.videoClick.emit({
                value: video,
                $event: $event
            });
            $event.preventDefault();
        };
        return VideoThumbnailComponent;
    }());
    VideoThumbnailComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uxg-video-thumbnail',
                    template: "<ng-container *ngIf=\"video\">\n  <a (click)=\"onVideoClick(video, $event)\" href=\"#\">\n    <div class=\"play-button\" [attr.dense]=\"dense === '' || null\" [attr.large]=\"large === '' || null\">\n      <mat-icon [attr.dense]=\"dense === '' || null\" [attr.large]=\"large === '' || null\">play_arrow</mat-icon>\n    </div>\n    <img [src]=\"video.thumbnail\" [attr.alt]=\"video.alt\" />\n  </a>\n</ng-container>\n",
                    styles: [".mt-0{margin-top:0!important}.pt-0{padding-top:0!important}.mb-0{margin-bottom:0!important}.pb-0{padding-bottom:0!important}.ml-0{margin-left:0!important}.pl-0{padding-left:0!important}.mr-0{margin-right:0!important}.pr-0{padding-right:0!important}.m-0{margin:0!important}.p-0{padding:0!important}.mt-1{margin-top:4px!important}.pt-1{padding-top:4px!important}.mb-1{margin-bottom:4px!important}.pb-1{padding-bottom:4px!important}.ml-1{margin-left:4px!important}.pl-1{padding-left:4px!important}.mr-1{margin-right:4px!important}.pr-1{padding-right:4px!important}.m-1{margin:4px!important}.p-1{padding:4px!important}.mt-2{margin-top:8px!important}.pt-2{padding-top:8px!important}.mb-2{margin-bottom:8px!important}.pb-2{padding-bottom:8px!important}.ml-2{margin-left:8px!important}.pl-2{padding-left:8px!important}.mr-2{margin-right:8px!important}.pr-2{padding-right:8px!important}.m-2{margin:8px!important}.p-2{padding:8px!important}.mt-3{margin-top:16px!important}.pt-3{padding-top:16px!important}.mb-3{margin-bottom:16px!important}.pb-3{padding-bottom:16px!important}.ml-3{margin-left:16px!important}.pl-3{padding-left:16px!important}.mr-3{margin-right:16px!important}.pr-3{padding-right:16px!important}.m-3{margin:16px!important}.p-3{padding:16px!important}.mt-4{margin-top:24px!important}.pt-4{padding-top:24px!important}.mb-4{margin-bottom:24px!important}.pb-4{padding-bottom:24px!important}.ml-4{margin-left:24px!important}.pl-4{padding-left:24px!important}.mr-4{margin-right:24px!important}.pr-4{padding-right:24px!important}.m-4{margin:24px!important}.p-4{padding:24px!important}.mt-5{margin-top:48px!important}.pt-5{padding-top:48px!important}.mb-5{margin-bottom:48px!important}.pb-5{padding-bottom:48px!important}.ml-5{margin-left:48px!important}.pl-5{padding-left:48px!important}.mr-5{margin-right:48px!important}.pr-5{padding-right:48px!important}.m-5{margin:48px!important}.p-5{padding:48px!important}.mt-6{margin-top:96px!important}.pt-6{padding-top:96px!important}.mb-6{margin-bottom:96px!important}.pb-6{padding-bottom:96px!important}.ml-6{margin-left:96px!important}.pl-6{padding-left:96px!important}.mr-6{margin-right:96px!important}.pr-6{padding-right:96px!important}.m-6{margin:96px!important}.p-6{padding:96px!important}img{width:100%;border-radius:4px;box-shadow:0 3px 1px -2px rgba(0,0,0,.2),0 2px 2px 0 rgba(0,0,0,.14),0 1px 5px 0 rgba(0,0,0,.12)}a{display:block;position:relative}a:hover .play-button{padding:7px}a:hover .mat-icon{transform:scale(1.4)}.play-button{position:absolute;display:flex;align-items:center;justify-content:center;top:50%;left:50%;height:40px;width:40px;transform:translate(-50%,-50%);border-radius:50%}.play-button[dense]{width:32px;height:32px}.play-button[large]{width:64px;height:64px}"]
                },] }
    ];
    /** @nocollapse */
    VideoThumbnailComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Attribute, args: ['dense',] }] },
        { type: undefined, decorators: [{ type: core.Attribute, args: ['large',] }] }
    ]; };
    VideoThumbnailComponent.propDecorators = {
        video: [{ type: core.Input }],
        videoClick: [{ type: core.Output }]
    };

    var VideoThumbnailModule = /** @class */ (function () {
        function VideoThumbnailModule() {
        }
        return VideoThumbnailModule;
    }());
    VideoThumbnailModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, icon.MatIconModule],
                    declarations: [VideoThumbnailComponent],
                    exports: [VideoThumbnailComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.VideoThumbnailComponent = VideoThumbnailComponent;
    exports.VideoThumbnailModule = VideoThumbnailModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ffdc-uxg-angular-components-video-thumbnail.umd.js.map
