import { OnInit, OnDestroy, QueryList, EventEmitter, OnChanges, SimpleChanges, ChangeDetectorRef, AfterContentInit } from '@angular/core';
import { PlotComponent } from 'angular-plotly.js';
import { TraceComponent } from './directives/trace.component';
import { GroupTracesComponent } from './directives/groupTrace.component';
import { LegendComponent } from './directives/legend.component';
import { PaletteService, LazyloadScriptService } from '@ffdc/uxg-angular-components/core';
import { Observable } from 'rxjs';
export declare class ChartComponent implements OnInit, OnDestroy, OnChanges, AfterContentInit {
    private document;
    private paletteService;
    private cd;
    lazyLoadScriptService: LazyloadScriptService;
    plot: PlotComponent;
    traces?: QueryList<TraceComponent>;
    legend?: LegendComponent;
    groupTraces?: QueryList<GroupTracesComponent>;
    data: any[];
    private _config?;
    private _layout?;
    private _defaultLayout?;
    private paletteConfig?;
    private subscriptions;
    multiSelect: boolean;
    get config(): any;
    set config(value: any);
    get layout(): any;
    set layout(value: any);
    get revision(): number;
    set revision(value: number);
    onClick: EventEmitter<Array<Object>>;
    onSelected: EventEmitter<Array<Object>>;
    onDoubleClick: EventEmitter<Array<Object>>;
    private lastClick;
    private clickTimer;
    plotlyReady$: Observable<any>;
    constructor(document: any, paletteService: PaletteService, cd: ChangeDetectorRef, lazyLoadScriptService: LazyloadScriptService);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onSelect(event: any): void;
    private onEventClick;
    private refresh;
    private merge_options;
    private setDefautLayout;
    private setLayout;
    private setData;
}
