import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { FormControl } from '@angular/forms';
import { MatAutocompleteTrigger, MatAutocomplete, MatAutocompleteSelectedEvent } from '@angular/material/autocomplete';
import { MatChipInputEvent } from '@angular/material/chips';
import { Observable } from 'rxjs';
export interface Tag {
    label: string;
    isSelected?: boolean;
}
interface UXGFilterChanges {
    added: Tag[];
    removed: Tag[];
}
export declare class FilterTagsComponent implements OnInit {
    private hostElement;
    visible: boolean;
    removable: boolean;
    addOnBlur: boolean;
    separatorKeysCodes: number[];
    toHighlight: string;
    formCtrl: FormControl;
    filteredTags$: Observable<Tag[]>;
    selectedData: Tag[];
    private _data;
    set data(data: Tag[]);
    get data(): Tag[];
    placeholder: string;
    ariaLabel: string;
    changes: EventEmitter<UXGFilterChanges>;
    input: ElementRef<HTMLInputElement>;
    autocomplete: MatAutocomplete;
    trigger: MatAutocompleteTrigger;
    constructor(hostElement: ElementRef);
    ngOnInit(): void;
    add(event: MatChipInputEvent): void;
    remove(tag: Tag): void;
    onSelected(event: MatAutocompleteSelectedEvent): void;
    clearSelection(): void;
    onClick(): void;
    applyHighlight(tag: Tag): boolean;
    private isTag;
    private filter;
    getState(): Tag[];
    setState(data: Tag[]): void;
}
export {};
