import { ElementRef, EventEmitter, OnInit } from '@angular/core';
export interface ToggleBtn {
    label: string;
    value: string;
    matIcon?: string;
    isSelected?: boolean;
}
interface UXGFilterChanges {
    added: ToggleBtn[];
    removed: ToggleBtn[];
}
export declare class FilterToggleComponent implements OnInit {
    private hostElement;
    selectedValue: ToggleBtn | undefined;
    initialValue: ToggleBtn;
    previousValue: ToggleBtn;
    private _data;
    set data(data: ToggleBtn[]);
    get data(): ToggleBtn[];
    showIcon: boolean;
    showLabel: boolean;
    dense: boolean;
    uxgClass: string;
    changes: EventEmitter<UXGFilterChanges>;
    constructor(hostElement: ElementRef);
    ngOnInit(): void;
    onValueChange(val: ToggleBtn): void;
    clearSelection(): void;
    reset(): void;
    getState(): ToggleBtn[];
    setState(value: ToggleBtn[]): void;
}
export {};
