import { SelectionModel } from '@angular/cdk/collections';
import { NestedTreeControl } from '@angular/cdk/tree';
import { ElementRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { MatTreeNestedDataSource } from '@angular/material/tree';
import { Subscription } from 'rxjs';
export interface TreeNode {
    label: string;
    children?: TreeNode[];
    parent?: TreeNode;
    isSelected?: boolean;
}
interface UXGFilterChanges {
    added: TreeNode[];
    removed: TreeNode[];
}
export declare class FilterTreeComponent implements OnChanges {
    private hostElement;
    treeControl: NestedTreeControl<TreeNode, TreeNode>;
    dataSource: MatTreeNestedDataSource<TreeNode>;
    checkListSelection: SelectionModel<TreeNode>;
    selectedData: TreeNode[];
    subscription?: Subscription;
    private _data;
    set data(data: TreeNode[]);
    get data(): TreeNode[];
    multipleSelection: boolean;
    changes: EventEmitter<UXGFilterChanges>;
    constructor(hostElement: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    clearSelection(): void;
    toggleAllNodes(): void;
    descendantsAllSelected(node: TreeNode): boolean;
    descendantsPartiallySelected(node: TreeNode): boolean;
    itemSelectionToggle(node: TreeNode): void;
    leafItemSelectionToggle(node: TreeNode): void;
    checkAllParentsSelection(node: TreeNode): void;
    checkRootNodeSelection(node: TreeNode): void;
    getParentNode(currentNode: TreeNode): TreeNode | null;
    getRootNode(currentNode: TreeNode): TreeNode;
    isRootNodeSelected(node: TreeNode): boolean;
    hasChild: (_: number, node: TreeNode) => number | undefined;
    expandStart(node: TreeNode, el: HTMLElement): void;
    expandEnd(node: TreeNode, el: HTMLElement): void;
    getSelectedNodes(data: TreeNode[]): TreeNode[];
    getState(): TreeNode[];
    setState(data: any[]): void;
}
export {};
