import { AfterViewInit, ElementRef, EventEmitter } from '@angular/core';
import { Observable, ReplaySubject } from 'rxjs';
import { ResultGroup } from '../../global-search.model';
import { SearchConfig } from './global-search-overlay-config';
import { SearchOverlayRef } from './global-search-overlay-ref';
export declare class GlobalSearchOverlayComponent implements AfterViewInit {
    private readonly ref;
    private config;
    animationState: 'void' | 'enter' | 'leave';
    results$: ReplaySubject<ResultGroup[]>;
    resultsShown: number;
    resultsFound: number;
    filterSize: number;
    searchValue: string;
    searchTime: string;
    resultStatusTemplate: import("@angular/core").TemplateRef<any> | undefined;
    emptySearchTemplate: import("@angular/core").TemplateRef<any> | undefined;
    resultItemTemplate: import("@angular/core").TemplateRef<any> | undefined;
    groupBy: string | undefined;
    showFilter: boolean | undefined;
    maxItems: number | undefined;
    itemDivider: boolean | undefined;
    groupDivider: boolean | undefined;
    itemsLayout: "row" | "column" | undefined;
    results: Observable<ResultGroup[]>;
    searchTermChange: EventEmitter<string>;
    itemClick: EventEmitter<string>;
    searchClose: EventEmitter<void>;
    searchInput: ElementRef;
    private searchDebounce;
    constructor(ref: SearchOverlayRef, config: SearchConfig);
    handleKeydown(event: KeyboardEvent): void;
    ngAfterViewInit(): void;
    closeSearch(): void;
    onItemClick(item: any): void;
    toggleFilter(resultGroup: ResultGroup): void;
    private get;
    private groupByResults;
}
