import { ElementRef, EventEmitter, OnChanges, SimpleChanges, TemplateRef } from '@angular/core';
import { Subject } from 'rxjs';
import { GlobalSearchOverlayService } from './services/global-search-overlay.service';
export declare class UxgGlobalSearch implements OnChanges {
    private overlayService;
    groupBy?: string;
    resultItemTemplate?: TemplateRef<any>;
    emptySearchTemplate?: TemplateRef<any>;
    resultStatusTemplate?: TemplateRef<any>;
    showFilter: boolean;
    maxItems?: number;
    itemDivider: boolean;
    groupDivider: boolean;
    itemsLayout: 'row' | 'column';
    results: any[];
    resultItemClick: EventEmitter<any>;
    searchTermChange: EventEmitter<string>;
    searchClose: EventEmitter<void>;
    results$: Subject<any[]>;
    get searchInput(): ElementRef;
    constructor(overlayService: GlobalSearchOverlayService);
    private ref?;
    private componentRef?;
    openSearch(): void;
    closeSearch(): void;
    ngOnChanges(changes: SimpleChanges): void;
}
