import { OnInit, OnDestroy, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { MatTable } from '@angular/material/table';
import { PageEvent } from '@angular/material/paginator';
import { MatCheckbox } from '@angular/material/checkbox';
import { UxgColumn, UxgSort, UxgPage, UxgTableSelectEvent, UxgActionColumnPosition } from './table.models';
import { CdkDropList } from '@angular/cdk/drag-drop';
export declare class TableComponent implements OnInit, OnDestroy, OnChanges {
    table: MatTable<any>;
    get data(): Array<any>;
    set data(data: Array<any>);
    get columnsToDisplay(): Array<string>;
    set columnsToDisplay(columnsToDisplay: Array<string>);
    columns: Array<UxgColumn>;
    showTotalRows: boolean;
    showTableHeader: boolean;
    totalData: any;
    stickyHeader: boolean;
    stickyFooter: boolean;
    columnDragEnable: boolean;
    private uxgMultiSelectColumn;
    private _selectedIndex;
    get selectedKeys(): number[];
    set selectedKeys(selectedIndex: number[]);
    singleSelect: boolean;
    multiSelect: boolean;
    selectChanged: EventEmitter<UxgTableSelectEvent>;
    multiSelectSingleRowClicked: EventEmitter<any>;
    sortChanged: EventEmitter<UxgSort>;
    pageEnable: boolean;
    paging?: UxgPage;
    pageChanged: EventEmitter<PageEvent>;
    enableEdit: boolean;
    enableDelete: boolean;
    enableSend: boolean;
    actionColumnPosition: UxgActionColumnPosition;
    rowRemoved: EventEmitter<any>;
    rowUpdated: EventEmitter<any>;
    rowSend: EventEmitter<any>;
    selections: any[];
    dataToComponent: Array<any>;
    columnsToDisplayToComponent: Array<string>;
    previousIndex: number;
    private _data;
    private _columnsToDisplay;
    private uxgTableEdit;
    private uxgTableActionColumn;
    private editRowOrigin;
    constructor();
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    sortData($event: UxgSort): void;
    singleSelectRowClick(row: any): void;
    multiSelectRowClick(row: any): void;
    multiSelectAllRows($event: MatCheckbox): void;
    applyPageChanges($event: PageEvent): void;
    getTotalRowCell(column: UxgColumn): string;
    emitSelectEvent(): void;
    emitClickEvent(data: any): void;
    columnDragStarted($event: CdkDropList, index: number): void;
    columnDropped($event: CdkDropList, index: number): void;
    rowEditClick(row: any): void;
    rowSendTriggered(row: any): void;
    rowEditConfirm(newRow: any): void;
    rowEditCancel(row: any): void;
    rowDelete(row: any): void;
    ngOnDestroy(): void;
    applyDefaultPaging(): void;
    localSort(sort: UxgSort): any[];
    getSortColumnType(columnName: string): string | undefined;
    localPaging(page: PageEvent): void;
    resetIndexWithMultiSelectRow(index: number): number;
    resetActionRow(): void;
    isRowSelected(row: any): boolean;
    getSelectedIndex(row: any): number;
    addOrUpdateActionColumnToColumnsToDisplay(): void;
    removeActionColumnsFromColumnsToDisplay(): void;
}
