import { Sort, SortDirection } from '@angular/material/sort';
import { EventEmitter } from '@angular/core';
export interface UxgSort extends Sort {
    active: string;
    direction: SortDirection;
}
export interface UxgColumn {
    id?: string;
    name: string;
    type: UxgColumnType;
    align?: 'left' | 'right' | 'center';
    displayName?: string;
    cellTemplate?: any;
    cellTemplateEmiter?: EventEmitter<any>;
    cellEditTemplate?: any;
}
export declare enum UxgColumnType {
    string = "string",
    number = "number",
    date = "date",
    typedouble = "typedouble",
    cellTemplate = "cellTemplate"
}
export declare enum UxgActionColumnPosition {
    start = "start",
    end = "end"
}
export interface UxgPage {
    disabled?: boolean;
    length?: number;
    hidePageSize?: boolean;
    showFirstLastButtons?: boolean;
    pageIndex?: number;
    pageSize?: number;
    pageSizeOptions?: number[];
}
export interface UxgTableSelectEvent {
    singleSelect: boolean;
    data: any[];
}
export declare const UxgDefaultPaging: UxgPage;
