import { InjectionToken } from '@angular/core';
import { ToastPosition } from './toaster.model';
export declare const TOASTER_CONFIG: InjectionToken<ToasterConfig>;
export declare class ToasterConfig {
    /**
     * Status chooses color scheme for the toast.
     * */
    type: string;
    /**
     * Duration is timeout between toast appears and disappears. 0 keeps the toast indefinitely on the screen
     * */
    duration: number;
    /**
     * Determines where on the screen toast have to be rendered.
     * */
    position: ToastPosition;
    /**
     * Destroy by click means you can hide the toast by clicking it.
     * */
    destroyByClick: boolean;
    constructor(config: Partial<ToasterConfig>);
}
