import { EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { TooltipComponent } from '@angular/material/tooltip';
import { ColorScale, LazyloadScriptService, PaletteConfig, PaletteService } from '@ffdc/uxg-angular-components/core';
import { PlotComponent } from 'angular-plotly.js';
import { Observable, Subscription } from 'rxjs';
import { VectorMapCountry, VectorMapDataSource, VectorMapLegend, VectorMapView } from './vector-map.models';
export declare class VectorMapComponent implements OnInit, OnDestroy, OnChanges {
    paletteService: PaletteService;
    lazyLoadScriptService: LazyloadScriptService;
    plot: PlotComponent;
    tooltip: TooltipComponent;
    title: string;
    dataSource: VectorMapDataSource;
    showLegend: boolean;
    autoResize: boolean;
    click: EventEmitter<Partial<VectorMapCountry>>;
    viewChange: EventEmitter<VectorMapView>;
    countries: VectorMapCountry[];
    data: any[];
    layout: any;
    config: any;
    style: Partial<CSSStyleDeclaration>;
    paletteConfig: PaletteConfig;
    legend: VectorMapLegend[];
    viewId: string | null;
    views: VectorMapView[] | null;
    tooltipTop: string;
    tooltipLeft: string;
    max: number;
    subscriptions: Subscription[];
    plotlyReady$: Observable<any>;
    constructor(paletteService: PaletteService, lazyLoadScriptService: LazyloadScriptService);
    ngOnInit(): void;
    ngOnChanges({ dataSource, showLegend }: SimpleChanges): void;
    ngOnDestroy(): void;
    onWindowResize(): void;
    refresh(): void;
    getLegendValue(value: number, max: number): number;
    getData(): Partial<VectorMapCountry>[];
    setLayout(layout?: any): void;
    setConfig(config?: any): void;
    setStyle(style?: Partial<CSSStyleDeclaration>): void;
    setView(): void;
    setPlotData(): void;
    setCountries(data: Partial<VectorMapCountry>[]): void;
    setLegend(colorScale: ColorScale): void;
    onHover({ points: [point] }: {
        points: Array<any>;
    }): void;
    onUnHover(): void;
    onPlotClick({ points: [point] }: {
        points: Array<any>;
    }): void;
    onViewChange($event: any): void;
}
