export interface VectorMapCountry {
    value: number;
    name: string;
    code: string;
}
export interface VectorMapView {
    id: string;
    text: string;
}
export interface VectorMapViewsDataSource {
    data: Record<string, Partial<VectorMapCountry>[]>;
    views: VectorMapView[];
}
export declare type VectorMapDataSource = Partial<VectorMapCountry>[] | VectorMapViewsDataSource;
export declare const COUNTRIES: VectorMapCountry[];
export interface VectorMapLegend {
    text: string;
    color: string;
}
export declare const DEFAULT_DATA: {
    type: string;
    hoverinfo: string;
    autocolorscale: boolean;
    reversescale: boolean;
    marker: {
        line: {};
    };
    tick0: number;
    zmin: number;
    zmax: number;
    showscale: boolean;
};
export declare const DEFAULT_LAYOUT: {
    autosize: boolean;
    geo: {
        showframe: boolean;
        showcoastlines: boolean;
        projection: {
            type: string;
        };
        center: {
            lat: number;
            lon: number;
        };
    };
    margin: {
        l: number;
        r: number;
        b: number;
        t: number;
        pad: number;
    };
};
export declare const DEFAULT_CONFIG: {
    displayModeBar: boolean;
    responsive: boolean;
};
export declare const DEFAULT_STYLE: {
    position: string;
    width: string;
    height: string;
};
