import { OnDestroy, TemplateRef } from '@angular/core';
import { UxgWizardPageComponent } from '../wizard-page/wizard-page.component';
import { PageCollectionService } from './page-collection.service';
import { Observable, Subscription } from 'rxjs';
import { ButtonHubService } from './button-hub.service';
export declare class WizardNavigationService implements OnDestroy {
    pageCollection: PageCollectionService;
    buttonService: ButtonHubService;
    previousButtonSubscription: Subscription;
    nextButtonSubscription: Subscription;
    doneButtonSubscription: Subscription;
    cancelButtonSubscription: Subscription;
    private _currentChange;
    private _wizardDone;
    private _currentPage;
    private _wizardCancel;
    private _movedToNextPage;
    private _movedToPreviousPage;
    get currentPageChange(): Observable<UxgWizardPageComponent>;
    get currentPageTitle(): TemplateRef<any> | null;
    get currentPageDescription(): TemplateRef<any> | null;
    get currentPageIsFirst(): boolean;
    get currentPageIsLast(): boolean;
    get currentPage(): UxgWizardPageComponent | null;
    set currentPage(page: UxgWizardPageComponent | null);
    setFirstPageCurrent(): void;
    get wizardDone(): Observable<boolean>;
    get wizardCancel(): Observable<any>;
    cancel(): void;
    constructor(pageCollection: PageCollectionService, buttonService: ButtonHubService);
    ngOnDestroy(): void;
    get movedToNextPage(): Observable<boolean>;
    next(): void;
    forceNext(): void;
    checkAndCommitCurrentPage(buttonType: string): void;
    get movedToPreviousPage(): Observable<boolean>;
    previous(): void;
    goTo(pageOrId: UxgWizardPageComponent | string): void;
}
