import { EventEmitter } from '@angular/core';
import { WizardNavigationService } from '../services/wizard-navigation.service';
import { ButtonHubService } from '../services/button-hub.service';
import { MediaObserver } from '@angular/flex-layout';
export declare type UxgWizardButtonType = 'cancel' | 'previous' | 'next' | 'done' | 'custom';
export declare class UxgWizardButtonComponent {
    navService: WizardNavigationService;
    buttonService: ButtonHubService;
    media: MediaObserver;
    type: UxgWizardButtonType;
    disabled: boolean;
    hidden: boolean;
    alwaysShow: boolean;
    wasClicked: EventEmitter<string>;
    constructor(navService: WizardNavigationService, buttonService: ButtonHubService, media: MediaObserver);
    private checkDefaultType;
    get isNext(): boolean;
    get isPrevious(): boolean;
    get isDone(): boolean;
    get isCancel(): boolean;
    get isCustom(): boolean;
    get isDisabled(): boolean;
    get isHidden(): boolean;
    get disabledAttribute(): string | null;
    click(): void;
}
