import { AfterContentInit, EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { ButtonHubService } from './services/button-hub.service';
import { PageCollectionService } from './services/page-collection.service';
import { WizardNavigationService } from './services/wizard-navigation.service';
import { UxgWizardPageComponent } from './wizard-page/wizard-page.component';
export declare class UxgWizardComponent implements OnDestroy, AfterContentInit {
    navService: WizardNavigationService;
    pageCollection: PageCollectionService;
    buttonService: ButtonHubService;
    pages: QueryList<UxgWizardPageComponent>;
    showPageTitles: boolean;
    showCloseButton: boolean;
    startingPage: number;
    cancel: EventEmitter<any>;
    done: EventEmitter<any>;
    currentPageChange: EventEmitter<any>;
    currentPageId: number;
    private subscriptions;
    swipeCoord: [number, number];
    swipeTime: number;
    get currentPage(): UxgWizardPageComponent | null;
    set currentPage(page: UxgWizardPageComponent | null);
    get isLast(): boolean;
    get isFirst(): boolean;
    ngAfterContentInit(): void;
    constructor(navService: WizardNavigationService, pageCollection: PageCollectionService, buttonService: ButtonHubService);
    ngOnDestroy(): void;
    onStepClick(page: UxgWizardPageComponent): void;
    swipe(e: TouchEvent, when: string): void;
    private listenForCancelChanges;
    private listenForDoneChanges;
    private listenForPageChanges;
}
